//=============================================================================================================
// ivymain
//-------------------------------------------------------------------------------------------------------------
//
// main file for ivy playstation game, includes main() and game loop, and pretty much everything at 
// the moment, but thatll be fixed in the future.
//
//=============================================================================================================
#define GLOBAL_OWNERSHIP
#define NOPROJECTILES 50
#define FIREDELAY 5

//includes -----------------------
#include <libps.h>		 
#include <stdio.h>
#include "defines.h" 
#include "structures.h" 
#include "globals.h"  
#include "graphics.h"
#include "prog1.h"
#include "pad.h"

// globals -----------------------
int gamestate = 1, datadisp=1, cameraon = 1;
GsSPRITE sp_floor;
GsSPRITE Sprite_p1;
GsSPRITE Sprite_p2;
GsSPRITE sp_bullet;
GsSPRITE sp_overlay;
GsSPRITE sp_text;
GsSPRITE sp_title;
GsSPRITE sp_loading;
GsSPRITE sp_splash;

int tile_appear_style = 1;	// 0 = normal
														// 1 = slide
														// 2 = rush

int anim_timer;
projectile projlist[NOPROJECTILES+1];
int GLO_mapoffsetx = -96,GLO_mapoffsety = -96-48;




// start program here ------------
void main(void) {
	tile playfield[PLAYWIDTH][PLAYHEIGHT];					//map		
	player p1,p2;	
	int tstages = 12;
	
	//load stuff and show splash screens
	InitGfx();
	Gfx.FntID = LoadFont();
	InitPads();	
	
	StartFrame(); EndFrame();
	loadprogress(0, tstages);

	//load gfx
	if(!ConfigureSprite(&sp_loading, "gfx/loading.tim", 10, 10)){	ResetGraph(3);	return;	}
	loadprogress(1, tstages);
	if(!ConfigureSprite(&sp_title, "gfx/title.tim", 10, 10))	{	ResetGraph(3);	return;	}
	loadprogress(3, tstages);
	if(!ConfigureSprite(&Sprite_p1, "gfx/player1.tim", 10, 10))	{	ResetGraph(3);	return;	}
	loadprogress(4, tstages);
	if(!ConfigureSprite(&Sprite_p2, "gfx/player2.tim", 10, 10))	{	ResetGraph(3);	return;	}
	loadprogress(5, tstages);
	if(!ConfigureSprite(&sp_floor, "gfx/tile.tim", 10, 10))		{	ResetGraph(3);	return;	}
	loadprogress(6, tstages);
	if(!ConfigureSprite(&sp_bullet, "gfx/bullet.tim", 10, 10))	{	ResetGraph(3);	return;	}
	loadprogress(7, tstages);
	if(!ConfigureSprite(&sp_overlay, "gfx/overlay.tim", 10, 10)){	ResetGraph(3);	return;	}
	loadprogress(8, tstages);
	if(!ConfigureSprite(&sp_text, "gfx/text.tim", 10, 10))	{		ResetGraph(3);	return;	}
	loadprogress(9, tstages);
	if(!ConfigureSprite(&sp_splash, "gfx/SPLASHES.TIM", 10, 10))	{		ResetGraph(3);	return;	}
	loadprogress(10, tstages);


	buildmap(playfield);
	resetplayers(&p1,&p2);
	initplayers(&p1,&p2);
	
	loadprogress(11, tstages);
	
	sp_floor.x = 0;
	sp_floor.y = 0;
	sp_floor.u = 1;
	sp_floor.v = 1;
	sp_floor.w = 16;
	sp_floor.h = 16;
	// game loop ==============================================================================
	loadprogress(12, tstages);

	
	splashme();

	do 
	{
		if(gamestate == 1){							//title
			dotitlescreen();
			gamestate = 2;
		}	
		
		if(gamestate == 2){							//game
			GetUserInput(&p1, &p2);
			GameLogic(&p1, &p2, playfield);
			DrawFrame(&p1, &p2, playfield, &sp_floor); 
		}      	
		if(gamestate == 4){							//win game
			endgame();	
			resetplayers(&p1,&p2);
			initplayers(&p1, &p2);
			gamestate = 2;
		}
		if(gamestate == 5){							//endgame
			ammoout(&p1, &p2, playfield);	
			gamestate = 2;
		}

		
		
		if(gamestate == 10){							//end
			//quit();	
		StartFrame();
			FntPrint(Gfx.FntID, "~c090\n: ivy.\n\n");
			FntPrint(Gfx.FntID, "~c090\n\n\ngame end.\n\n");
			gamestate = 0;
		EndFrame();
		ResetGraph(3);	
		}

		
    
	}while (gamestate != 0);


	
	ResetGraph(3);	

}

// ==============================================================================================
int GetUserInput(player *p1, player *p2){
	int p1newattack  = 0, p2newattack  = 0;

	p1->xvel = 0; 
	p1->yvel = 0;
	p2->xvel = 0;
	p2->yvel = 0;
	p1->anim = 0;
	p2->anim = 0;
	p1->adirx = 0;
	p1->adiry = 0;
	p2->adirx = 0;
	p2->adiry = 0;

	

	GetPadData(0, &Pad0);
	GetPadData(1, &Pad1);

	// player 1 -----------------------------------------
	if(Pad0.State & PadSelect){	//quit program
		gamestate = 10;
	}	
	if(Pad0.State & PadDown){
		p1->yvel=p1->speed;
		p1->anim = 1;
		p1->dir = 1;
	}
	if(Pad0.State & PadUp){		//move player
		p1->yvel=-p1->speed;
		p1->anim = 1;
		p1->dir = 2;
	}
	
	if(Pad0.State & PadRight){		
		p1->xvel=p1->speed;
		p1->anim = 1;
		p1->dir = 3;
	}

	if(Pad0.State & PadLeft){
		p1->xvel=-p1->speed;
		p1->anim = 1;
		p1->dir = 4;
	}
	
	if((Pad0.State & PadUp) && (Pad0.State & PadRight)){		
		p1->dir = 5;
	}
	if((Pad0.State & PadDown) && (Pad0.State & PadRight)){		
		p1->dir = 6;
	}
	if((Pad0.State & PadUp) && (Pad0.State & PadLeft)){		
		p1->dir = 7;
	}
	if((Pad0.State & PadDown) && (Pad0.State & PadLeft)){		
		p1->dir = 8;
	}
	

	if(Pad0.State & PadCross){
		p1newattack = 1;
		p1->adiry = 1;
	}
	if(Pad0.State & PadTriangle){
		p1newattack = 1;
		p1->adiry = -1;
	}

	if(Pad0.State & PadSquare){
		p1newattack = 1;
		p1->adirx = -1;
	}
	if(Pad0.State & PadCircle){
		p1newattack = 1;
		p1->adirx = 1;
	}


	if (p1newattack == 1){
		if(p1->attacking == 0){
			if (p1->ammo > 0){
				p1->attacking = 1;
				p1->ammo--;
			}
			else
			 p1->ammo_r = 254;
		}
	}

	





	if((Pad0.State & PadL1) && (Pad0.State & PadR1)){
		initplayers(p1, p2);		
	}

	if(Pad0.State & PadL2){	
		cameraon = 1;
	}
	if(Pad0.State & PadR2){	
		cameraon = 2;
	}		
	

	// player 2 -----------------------------------------

	

	if(Pad1.State & PadDown){
		p2->yvel=p2->speed;
		p2->anim = 1;
		p2->dir = 1;
	}
	if(Pad1.State & PadUp){		//move player
		p2->yvel=-p2->speed;
		p2->anim = 1;
		p2->dir = 2;
	}
	
	if(Pad1.State & PadRight){
		p2->xvel=p2->speed;
		p2->anim = 1;
		p2->dir = 3;
	}

	if(Pad1.State & PadLeft){
		p2->xvel=-p2->speed;
		p2->anim = 1;
		p2->dir = 4;
	}

	if((Pad1.State & PadUp) && (Pad1.State & PadRight)){		
		p2->dir = 5;
	}
	if((Pad1.State & PadDown) && (Pad1.State & PadRight)){		
		p2->dir = 6;
	}
	if((Pad1.State & PadUp) && (Pad1.State & PadLeft)){		
		p2->dir = 7;
	}
	if((Pad1.State & PadDown) && (Pad1.State & PadLeft)){		
		p2->dir = 8;
	}
	
	if(Pad1.State & PadCross){
		p2newattack = 1;
		p2->adiry = 1;
	}
	if(Pad1.State & PadTriangle){
		p2newattack = 1;
		p2->adiry = -1;
	}

	if(Pad1.State & PadSquare){
		p2newattack = 1;
		p2->adirx = -1;
	}
	if(Pad1.State & PadCircle){
		p2newattack = 1;
		p2->adirx = 1;
	}


	if (p2newattack == 1){
		if(p2->attacking == 0){
			if (p2->ammo > 0){
				p2->attacking = 1;
				p2->ammo--;
			}
			else
			 p2->ammo_r = 254;
		}
	}
}

// ==============================================================================================
int GameLogic(player *p1, player *p2, tile map[][PLAYHEIGHT]){
	 
	if ((p1->ammo <= 0) && (p2->ammo <= 0)){
		gamestate = 5;
		delay(1000);

	}
	moveplayer( p1,  p2,  map);
	moveplayer( p2,  p2,  map);
	moveprojectiles(p1, p2);
	collideprojectiles(p1, p2, map);
	if (cameraon == 1)
		scroll(p1);
	else
		scroll(p2);
	 
	//zoom();
	 
}



// ==============================================================================================
int DrawFrame(player *p1, player *p2, tile map[][PLAYHEIGHT], GsSPRITE *floorsprite){

int i,a = 1;
	// animate
	anim_timer++;
	anim_timer = i_wrap(anim_timer, 10);
	if (p1->anim == 1) animate(p1);
	if (p2->anim == 1) animate(p2);

	StartFrame(); 

	if(p2->health <= 0){		// p1 scores
		if (p1->wins == 3) a = 2;
		playerscore(p1, p2, a);
	}
	if(p1->health <= 0){
		if (p2->wins == 3) a = 2;
		playerscore(p2, p1, a);
	}

	if (cameraon == 1)
		pointto(p2);
	 else
		pointto(p1);

	drawoverlay(p1, p2);

	// draw players + projectiles -----------------

	Sprite_p1.x = p1->obj.x + p1->sprite_offx + GLO_mapoffsetx;
	Sprite_p1.y = p1->obj.y + p1->sprite_offy + GLO_mapoffsety;
	Sprite_p1.u = p1->obj.u;
	Sprite_p1.v = p1->obj.v;

	Sprite_p2.x = p2->obj.x + p2->sprite_offx + GLO_mapoffsetx;
	Sprite_p2.y = p2->obj.y + p2->sprite_offy + GLO_mapoffsety;	
	Sprite_p2.u = p2->obj.u;
	Sprite_p2.v = p2->obj.v;

	fadelplayershade(p1,4, 128, 4);
	fadelplayershade(p2,4, 128, 4);

	Sprite_p1.r = p1->r;
	Sprite_p1.g = p1->g;
	Sprite_p1.b = p1->b;

	Sprite_p2.r = p2->r;
	Sprite_p2.g = p2->g;
	Sprite_p2.b = p2->b;

	if (p1->obj.y > p2->obj.y){		
		obscureplayer(p1, map);
		GsSortSprite(&Sprite_p1, Gfx.pOT, 0);
		obscureplayer(p2, map);
		GsSortSprite(&Sprite_p2, Gfx.pOT, 0);
	}	
	else{
		obscureplayer(p2, map);
		GsSortSprite(&Sprite_p2, Gfx.pOT, 0);
		obscureplayer(p1, map);
		GsSortSprite(&Sprite_p1, Gfx.pOT, 0);
	}
	for(i = 0; i < NOPROJECTILES; i++){
		if(projlist[i].active == 1){
			sp_bullet.x = projlist[i].obj.x + GLO_mapoffsetx;
			sp_bullet.y = projlist[i].obj.y + GLO_mapoffsety;
			
			GsSortSprite(&sp_bullet, Gfx.pOT, 0);
		}
	}

	drawfloor(map);				//draw floor (visible map)

	EndFrame();
}


































// setup players ==========================================================================

void resetplayers(player *p1, player *p2){

	//player 1
	Sprite_p1.x = 0;
	Sprite_p1.y = 0;
	Sprite_p1.u = 0;
	Sprite_p1.v = 0;
	Sprite_p1.w = 16;
	Sprite_p1.h = 24;

	p1->obj.sprite = &Sprite_p1;
	
	p1->obj.x=160; 	
	p1->obj.y=256; 
	p1->obj.w=16; 	
	p1->obj.h=16; 
	p1->obj.rotation=0; 
	p1->obj.scale=1; 
	
	p1->c_box.sprite = NULL;
	p1->c_box.x = 0; 
	p1->c_box.y = 0;
	p1->c_box.w = 16; 
	p1->c_box.h = 8;
	p1->c_box.rotation = 0;
	p1->c_box.scale = 1;
	
	p1->sprite_offx = 0;
	p1->sprite_offy = -8;
	p1->id = 1;
	
	p1->xvel=0; 	
	p1->yvel=0; 
	p1->speed = 2;
	p1->health=100; 	
	p1->ammo=200;		 
	p1->weapon=1;
	p1->frame = 1; 	
	p1->maxframes = 2;
	p1->animateon = 5; 	
	p1->fcounter = 1;
	p1->anim = 1;
	p1->attacking = 0;
	p1->adirx = 0;
	p1->adiry = 0;	
	p1->dir = 3;	
	p1->r = 128;
	p1->g = 128;
	p1->b = 128;
	p1->ammo_r = 128;
	


	//player 2
	Sprite_p2.x = 0;
	Sprite_p2.y = 0;
	Sprite_p2.u = 0;
	Sprite_p2.v = 0;
	Sprite_p2.w = 16;
	Sprite_p2.h = 24;

	p2->obj.sprite = &Sprite_p2;
	
	p2->obj.x=336; 	
	p2->obj.y=256; 
	p2->obj.w=16; 	
	p2->obj.h=16; 
	p2->obj.rotation=0; 
	p2->obj.scale=1; 
	
	p2->c_box.sprite = NULL;
	p2->c_box.x = 0; 
	p2->c_box.y = 0;
	p2->c_box.w = 16; 
	p2->c_box.h = 8;
	p2->c_box.rotation = 0;
	p2->c_box.scale = 1;
	
	p2->sprite_offx = 0;
	p2->sprite_offy = -8;
	p2->id = 2;
	
	p2->xvel=0; 	
	p2->yvel=0; 
	p2->speed = 2;
	p2->health=100; 	
	p2->ammo=200;		 
	p2->weapon=1;
	p2->frame = 1; 	
	p2->maxframes = 2;
	p2->animateon = 5; 	
	p2->fcounter = 1;
	p2->anim = 1;
	p2->attacking = 0;
	p2->adirx = 0;
	p2->adiry = 0;	
	p2->dir = 3;	
	p2->r = 128;
	p2->g = 128;
	p2->b = 128;
	p2->ammo_r = 128;

GLO_mapoffsetx = -96;
GLO_mapoffsety = -96-48;
}



void initplayers(player *p1, player *p2){
	p1->score = 0;
	p1->wins = 0;
	
	p2->score = 0;
	p2->wins = 0;
	
}
// setup map ==============================================================================
void buildmap(tile playfield[][PLAYHEIGHT]){
int x,y;
int simplemap[32][32] = {
{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},	//1
{2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,3,3,2},	//5
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},	//10
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,3,3,3,3,3,3,3,0,0,3,3,3,3,3,3,3,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,2,1,1,1,1,1,1,0,0,1,1,1,1,1,1,2,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2},	//15
{2,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2},	//20
{2,0,0,0,0,0,0,0,2,3,3,3,3,3,3,0,0,3,3,3,3,3,3,2,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,2},	
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},
{2,0,0,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,0,2},	//25
{2,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,2,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,2},
{2,0,0,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,0,3,2,0,2},
{2,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,0,2},
{2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2},	//30
{1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
};
//0= floor
//1= wall
//2= pillartop + collision
//3= pillartop no collision

	for(y=0;y<=32;y++){
		for(x=0; x<32;x++){
			if (simplemap[y][x] == 0){			//floor
				playfield[x][y].typex=0;
				playfield[x][y].typey=rand()%4;
				playfield[x][y].mask = 0;
				playfield[x][y].collide = 0;
			}
			if (simplemap[y][x] == 1){			//wall
				playfield[x][y].typex=2;
				playfield[x][y].typey=rand()%4;
				playfield[x][y].mask = 0;
				playfield[x][y].collide = 1;
			}
			if (simplemap[y][x] == 2){			//pillartop + collision
				playfield[x][y].typex=1;
				playfield[x][y].typey=rand()%4;
				playfield[x][y].mask = 0;
				playfield[x][y].collide = 1;
			}
			if (simplemap[y][x] == 3){			//pillartop no collision
				playfield[x][y].typex=1;
				playfield[x][y].typey=rand()%4;
				playfield[x][y].mask = 1;
				playfield[x][y].collide = 0;
			}
		}
	}

}


// bounding box collision -----------------------------------------------------------------

int bbox_collision(actor *a, actor *b){

if(!(((a->x + a->w) <= b->x) 	|| 
	(a->x >= (b->x + b->w)) 	|| 
	((a->y + a->h) <= b->y)  	|| 
	(a->y >= (b->y + b->h)) ))	
	return 1;

else 	
	return 0;

}
// end bounding box collision --------------------------------------------------------------

// get collision direction(bb) -------------------------------------------------------------

int bbox_collision_dir(actor *a, actor *b){

		if ( (a->y <= (b->y + b->h) ) && ( (a->y + a->h) > (b->y + b->h)))	//intersects bottom
			return 1;
		if ((a->y < b->y) && ((a->y + a->h) >= b->y))						//intersects top
			return 4;
		if ((a->x < b->x) && ((a->x + a->w) >= b->x ))						//intersects left
			return 2;
		if ((a->x <= (b->x + b->w)) && ((a->x + a->w) > (b->x + b->w)))		//intersects right
			return 3;

	return 0;
}
// end get collision direction(bb) ---------------------------------------------------------


int i_wrap(int a, int b){
	while (a > b)
		a-=b;
	return a;

}


// move players ----------------------------------------------------------------------------



void moveplayer(player *playertomove, player *opposition, tile map[][PLAYHEIGHT]){
	
	int oldx, oldy, squareonx, squareony, tx,ty, dir;
	actor tile_colbox;
	actor totest, otherplayer;
		
	tile_colbox.sprite = NULL;		
	tile_colbox.x = 0; 
	tile_colbox.y = 0;
	tile_colbox.w = 16; 
	tile_colbox.h = 16;
	tile_colbox.rotation = 0;
	tile_colbox.scale = 1;
	
	oldx = playertomove->obj.x;					//store in case of collision
	oldy = playertomove->obj.y;
	squareonx = playertomove->obj.x / 16;		//get what square we're on
 	squareony = playertomove->obj.y / 16;

 	playertomove->obj.x += playertomove->xvel;	//do move
 	playertomove->obj.y += playertomove->yvel;

 	playertomove->c_box.x = playertomove->obj.x;//adjust cboxes
 	playertomove->c_box.y = playertomove->obj.y;
	opposition->c_box.x = opposition->obj.x;
 	opposition->c_box.y = opposition->obj.y;
	
 	totest = playertomove->c_box;				//make new actors of the cboxes
 	otherplayer = opposition->c_box;
 	
	if (bbox_collision(&totest, &otherplayer)){	//collision test
		dir = bbox_collision_dir(&totest, &otherplayer);
		//FntPrint(Gfx.FntID, "~c000\n\n\ni am %d, clack @ %d", playertomove->id, dir);
		
		if ((dir == 1) || (dir == 4)){	//top or bottom
			playertomove->obj.y = oldy;
			dir = bbox_collision_dir(&totest, &otherplayer);
		}
		
		if ((dir == 2) || (dir == 3)){	//left or right
			playertomove->obj.x = oldx;
		}			
	}

	for(tx=-1; tx<2; tx++){
		for(ty=-1; ty<2; ty++){
			if (map[squareonx+tx][squareony+ty].collide == 1){
				tile_colbox.x = (squareonx+tx)*16;
				tile_colbox.y = (squareony+ty)*16-8;
				
				// check collision with map
				if (bbox_collision(&totest, &tile_colbox)){
					dir = bbox_collision_dir(&totest, &tile_colbox);
					//FntPrint(Gfx.FntID, "~c000\n\n\ni am %d, clack with map @ %d", playertomove->id, dir);

					
					if ((dir == 1) || (dir == 4)){	//top or bottom
						playertomove->obj.y = oldy;
					}
					if ((dir == 2) || (dir == 3)){	//left or right
						playertomove->obj.x = oldx;
					}				
				}			
			}		
		}
	}
	/*
	FntPrint(Gfx.FntID, "\n\n\n\n%d, %d, %d\n%d, %d, %d\n%d, %d, %d",
	map[squareonx-1][squareony-1].collide,
	map[squareonx][squareony-1].collide,
	map[squareonx+1][squareony-1].collide,
	map[squareonx-1][squareony].collide,
	map[squareonx][squareony].collide,
	map[squareonx+1][squareony].collide,
	map[squareonx-1][squareony+1].collide,
	map[squareonx][squareony+1].collide,
	map[squareonx+1][squareony+1].collide);*/
}
// end move players ------------------------------------------------------------------------
	
void scroll(player *targetp){

	int xout = targetp->obj.x + GLO_mapoffsetx;
	int yout = targetp->obj.y  + GLO_mapoffsety;
	int tdif, xm, ym;
	int scrollat = 64;

	if (xout <scrollat){
		tdif=(scrollat-xout)/2;
		GLO_mapoffsetx+=tdif;
	}
	else{
		if (xout>(SCNW-scrollat)){
			tdif=(xout-(SCNW-scrollat))/2;
			GLO_mapoffsetx-=tdif;
		}
	}
		if (yout < scrollat){
		tdif=(scrollat-yout)/2;
		GLO_mapoffsety+=tdif;
	}
	else{
		if (yout > (SCNH-scrollat)){
			tdif=(yout-(SCNH-scrollat))/2;
			GLO_mapoffsety-=tdif;
		}
	}
	
	//constrain to level boundaries
	xm = 16; ym = 16;
	if (GLO_mapoffsetx > xm) GLO_mapoffsetx = ym;
	if (GLO_mapoffsety > ym) GLO_mapoffsety = xm;
	if (GLO_mapoffsetx < -192-xm) GLO_mapoffsetx = -192-xm;
	if (GLO_mapoffsety < -272-ym) GLO_mapoffsety = -272-ym;

}



void obscureplayer(player *p, tile map[][PLAYHEIGHT]){

	int tx,ty;
	int squareonx, squareony;

	squareonx = p->obj.x / 16;
 	squareony = p->obj.y / 16;

	for(tx=-1; tx<2; tx++){
		for(ty=-1; ty<2; ty++){
			if (map[squareonx+tx][squareony+ty].mask == 1){
				sp_floor.x = 16*(squareonx+tx)+GLO_mapoffsetx;
				sp_floor.y = 16*(squareony+ty)+GLO_mapoffsety;		
				sp_floor.u = map[squareonx+tx][squareony+ty].typex*16;
				sp_floor.v = map[squareonx+tx][squareony+ty].typey*16;
				GsSortSprite(&sp_floor, Gfx.pOT, 0);
			}
		}
	}
}

void drawfloor(tile map[][PLAYHEIGHT]){
	int tx,ty;
	int startx, endx, starty, endy;

	startx = -(GLO_mapoffsetx / 16);
	endx = startx +21;
	starty = -(GLO_mapoffsety / 16);
	endy = starty +16;

 
	for(tx=startx;tx<endx;tx++){			
		for(ty=starty;ty<=endy;ty++){
			sp_floor.r = 128;
			sp_floor.g = 128;
			sp_floor.b = 128;
			sp_floor.x = 16*tx+GLO_mapoffsetx;
			sp_floor.y = 16*ty+GLO_mapoffsety;		
			
			if (tile_appear_style == 1){
				if(sp_floor.x < 32 ){
					sp_floor.r = sp_floor.x*4;					
					sp_floor.x -= (32-sp_floor.x);				
				}
				if(sp_floor.x > SCNW-32 ){
					//sp_floor.r = (SCNW-sp_floor.h)*4;	
					sp_floor.x += (SCNW-sp_floor.x);
				}			
				
				if(sp_floor.y < 32 ){
						sp_floor.r = sp_floor.y*4;	
						sp_floor.y -= (32-sp_floor.y);				
				}/*
				if(sp_floor.y > SCNH-32 ){
					sp_floor.r = (SCNH - sp_floor.y)*4;	
					sp_floor.y += (SCNH-sp_floor.y);
				}			*/
				sp_floor.g = sp_floor.r;
				sp_floor.b = sp_floor.r;
			}
			
			sp_floor.u = map[tx][ty].typex*16;
			sp_floor.v = map[tx][ty].typey*16;
			GsSortSprite(&sp_floor, Gfx.pOT, 0);
		}	
	}
}

void animate(player *animateme){

	if(animateme->animateon == anim_timer){
		animateme->frame ++;
		animateme->frame = i_wrap(animateme->frame, animateme->maxframes);
	}
	animateme->obj.u = (animateme->frame-1)*16;
	animateme->obj.v = animateme->dir*animateme->obj.sprite->h;
}

void moveprojectiles(player *p1, player *p2){
	
	static int counter = 0;
	int i;

	if ((p1->attacking >= 1)|| (p2->attacking >= 1)){
		
		projlist[counter].obj.w = 4;
		projlist[counter].obj.h = 4;
		projlist[counter].obj.u = 0;
		projlist[counter].obj.v = 0;		
		projlist[counter].type = 5;		
		
		if(p1->attacking >= 1) {
			if (p1->attacking == 1){
				projlist[counter].obj.x = p1->obj.x + 6;
				projlist[counter].obj.y = p1->obj.y;
				projlist[counter].xvel = p1->adirx * projlist[counter].type;
				projlist[counter].yvel = p1->adiry * projlist[counter].type;
				projlist[counter].owner = 1;
				projlist[counter].active = 1;
				p1->attacking++;
				counter = i_wrap(++counter,NOPROJECTILES);
			}
			else 
				if (p1->attacking < FIREDELAY)
					p1->attacking++;
				else
					p1->attacking=0;
		}	
		if(p2->attacking >= 1) {
			if (p2->attacking == 1){
				projlist[counter].obj.x = p2->obj.x + 6;
				projlist[counter].obj.y = p2->obj.y;
				projlist[counter].xvel = p2->adirx * projlist[counter].type;
				projlist[counter].yvel = p2->adiry * projlist[counter].type;
				projlist[counter].owner = 2;
				projlist[counter].active = 1;
				p2->attacking++;
				counter = i_wrap(++counter,NOPROJECTILES);
			}
			else 
				if (p2->attacking < FIREDELAY)
					p2->attacking++;
				else
					p2->attacking=0;
		}		
	}
	
	for(i = 0; i < NOPROJECTILES; i++){
		if(projlist[i].active == 1){
			projlist[i].obj.x += projlist[i].xvel;
			projlist[i].obj.y += projlist[i].yvel;
		}
	}
}
// -----------------------------------------------------------------------------------------
void collideprojectiles(player *p1, player *p2, tile map[][PLAYHEIGHT]){
	int i,squareonx, squareony;
	actor player1test, player2test, projtest, tile_colbox;

	player1test = p1->obj;
	player2test = p2->obj;

	tile_colbox.sprite = NULL;			
	tile_colbox.w = 16; 
	tile_colbox.h = 16;
	tile_colbox.rotation = 0;
	tile_colbox.scale = 1;

	for(i = 0; i < NOPROJECTILES; i++){
		if(projlist[i].active == 1){
			projtest = projlist[i].obj;
			squareonx = projlist[i].obj.x/16; 
			squareony = projlist[i].obj.y/16;

			if(map[squareonx][squareony].collide == 1){
				tile_colbox.x = squareonx*16;
				tile_colbox.y = squareony*16;
				if (bbox_collision(&projtest, &tile_colbox))
					projlist[i].active = 0;
			}
			if( (bbox_collision(&projtest, &player1test)) && (projlist[i].owner == 2) ){		
				p1->health-=projlist[i].type;
				p1->r = 255;
				p1->g = 64;
				p1->b = 64;
				projlist[i].active = 0;
			}
			if( (bbox_collision(&projtest, &player2test)) && (projlist[i].owner == 1) ){		
				p2->health-=projlist[i].type;
				p2->r = 255;
				p2->g = 64;
				p2->b = 64;
				projlist[i].active = 0;
			}			
		}
	}
}

void drawoverlay(player *p1, player *p2){
int i;

	//powerup icons --------------------
	//camera
	sp_overlay.y = 32;	
	sp_overlay.w = 8;
	sp_overlay.h = 8;
	sp_overlay.u = 33;
	sp_overlay.v = 35;

	if (cameraon == 1)
		sp_overlay.x = 46;
	else
		sp_overlay.x = 266;

	GsSortSprite(&sp_overlay, Gfx.pOT, 0);	

	//playerimage1 ---------------------

	sp_overlay.x = 18;
	sp_overlay.y = 4;
	sp_overlay.w = 32;
	sp_overlay.h = 32;
	sp_overlay.u = 0;
	sp_overlay.v = 35;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	//playerimage2 ---------------------
	sp_overlay.x = 270;
	sp_overlay.y = 4;
	sp_overlay.w = 32;
	sp_overlay.h = 32;
	sp_overlay.u = 0;
	sp_overlay.v = 68;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	//p1health -------------------------
	sp_overlay.x = 55;
	sp_overlay.y = 9;
	sp_overlay.w = p1->health;
	sp_overlay.h = 6;
	sp_overlay.u = 1;
	sp_overlay.v = 9;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	//p2health -------------------------
	sp_overlay.x = 167 + (100 - p2->health);
	sp_overlay.y = 9;
	sp_overlay.w = p2->health;
	sp_overlay.h = 6;
	sp_overlay.u = (100 - p2->health);
	sp_overlay.v = 17;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);


	//p1ammo ---------------------------
	sp_overlay.x = 55;
	sp_overlay.y = 18;
	sp_overlay.w = (p1->ammo/2);
	sp_overlay.h = 2;
	sp_overlay.u = 1;
	sp_overlay.v = 29;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);


	//p2ammo ---------------------------
	sp_overlay.x = 167 + (100-(p2->ammo/2));
	sp_overlay.y = 18;
	sp_overlay.w = p2->ammo/2;
	sp_overlay.h = 2;
	sp_overlay.u = 100-(p2->ammo/2);
	sp_overlay.v = 32;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	// outlines ------------
	sp_overlay.u = 0;
	sp_overlay.v = 0;
	sp_overlay.w = 102;
	sp_overlay.h = 8;
	sp_overlay.x = 54;
	sp_overlay.y = 8;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	sp_overlay.x = 166;
	sp_overlay.y = 8;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	//ammo outline
	sp_overlay.u = 0;
	sp_overlay.v = 24;
	sp_overlay.w = 102;
	sp_overlay.h = 4;

	if (p1->ammo_r > 128){
		p1->ammo_r -= 2;
		sp_overlay.r = p1->ammo_r;
		sp_overlay.g = 255 - p1->ammo_r;
		sp_overlay.b = 255 - p1->ammo_r;
	}	
	sp_overlay.x = 54;
	sp_overlay.y = 17;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	sp_overlay.r = 128;
	sp_overlay.g = 128;
	sp_overlay.b = 128;
	if (p2->ammo_r > 128){
		p2->ammo_r -= 2;
		sp_overlay.r = p2->ammo_r;
		sp_overlay.g = 255 - p2->ammo_r;
		sp_overlay.b = 255 - p2->ammo_r;
	}
	sp_overlay.x = 166;
	sp_overlay.y = 17;
	GsSortSprite(&sp_overlay, Gfx.pOT, 0);

	sp_overlay.r = 128;
	sp_overlay.g = 128;
	sp_overlay.b = 128;
	
	//wins
	sp_overlay.u = 33;
	sp_overlay.v = 60;
	sp_overlay.w = 8;
	sp_overlay.h = 8;
	sp_overlay.y = 38;	
	
	if (p1->wins >0){		
		for(i=0;i<p1->wins;i++){	
			sp_overlay.x = 18+ i*8;	
			GsSortSprite(&sp_overlay, Gfx.pOT, 0);
		}
	}
	
	if (p2->wins >0){	
		for(i=0;i<p2->wins;i++){	
			sp_overlay.x = 270+ i*8;
			GsSortSprite(&sp_overlay, Gfx.pOT, 0);	
		}
	}

}

void pointto(player *pointto){
	
	sp_overlay.w = 16;
	sp_overlay.h = 16;	
	sp_overlay.u = 33;
	sp_overlay.v = 44;

	if (pointto->obj.y + GLO_mapoffsety < 0){
		sp_overlay.x = pointto->obj.x + GLO_mapoffsetx;
		sp_overlay.y = 2;
		GsSortSprite(&sp_overlay, Gfx.pOT, 0);
	}
	if(pointto->obj.y + GLO_mapoffsety > SCNH){
		sp_overlay.x = pointto->obj.x + GLO_mapoffsetx;
		sp_overlay.y = SCNH-24;
		GsSortSprite(&sp_overlay, Gfx.pOT, 0);
	}
	if (pointto->obj.x + GLO_mapoffsetx < 0){
		sp_overlay.x = 2;
		sp_overlay.y = pointto->obj.y + GLO_mapoffsety; 
		GsSortSprite(&sp_overlay, Gfx.pOT, 0);
	}
	if(pointto->obj.x + GLO_mapoffsetx > SCNW){
		sp_overlay.x = SCNW-24;
		sp_overlay.y = pointto->obj.y + GLO_mapoffsety;
		GsSortSprite(&sp_overlay, Gfx.pOT, 0);
	}
}

void fadelplayershade(player *drawme, int speed, int fadeto, int safety){
int maxout = fadeto+safety;
int minout = fadeto-safety;

	if (drawme->r > maxout)
		drawme->r -= speed;
	else
		if (drawme->r < minout)
			drawme->r += speed;
		else
			drawme->r = fadeto;

	if (drawme->g > maxout)
		drawme->g -= speed;
	else
		if (drawme->g < minout)
			drawme->g += speed;
		else
			drawme->g = fadeto;

	if (drawme->b > maxout)
		drawme->b -= speed;
	else
		if (drawme->b < minout)
			drawme->b += speed;
		else
			drawme->b = fadeto;
}

void playerscore(player *iscore, player *defeated, int achievment){
static int namex;
static int scorex;
static int on = 0, tmr=0;

	if (on == 0){
			namex = 240;
			scorex =  0;
			on = 1;
			tmr=0;
	}
	if (on ==1){
		
		tmr++;
		if (namex > (SCNW/2 - 64))
			namex -= (namex - (SCNW/2 - 64))/2;
		if (scorex < (SCNW/2 - 64))
			scorex += ((SCNW/2 - 64)-scorex)/2;

		sp_text.w = 128;
		sp_text.h = 32;
		sp_text.x = namex;
		sp_text.y = SCNH/2-32;
		sp_text.u = 0;
		if (iscore->id == 1)
			sp_text.v = 0;
		else
			sp_text.v = 32;
		GsSortSprite(&sp_text, Gfx.pOT, 0);
	
		sp_text.x = scorex;
		sp_text.y = SCNH/2;
		if (achievment == 1)	//match win
			sp_text.v = 64;
		else					//game win
			sp_text.v = 96;
		GsSortSprite(&sp_text, Gfx.pOT, 0);	

		if (tmr == 50){
			if (achievment != 1)	//match win
				gamestate = 4;
		
		iscore->wins++;
			if (iscore->id == 1){				
				resetplayers(iscore, defeated);
				}
			else{
				resetplayers(defeated, iscore);
				}
			on = 0;
		}
	}
}



void loadprogress(int stage, int totalstages){
	int i;

	StartFrame(); 
	sp_loading.u = 0;
	sp_loading.v = 0;
	sp_loading.w = 108;
	sp_loading.h = 38;
	sp_loading.x = (SCNW/2) - (sp_loading.w/2);
	sp_loading.y = (SCNH/2)- (sp_loading.h/2);	
	GsSortSprite(&sp_loading, Gfx.pOT, 0); 
		
	for(i=0;i<stage;i++){
		sp_loading.x = (SCNW/2) - ((totalstages*10)/2) + i*10;
		sp_loading.y = (SCNH/2) +19;
		sp_loading.u = 0;
		sp_loading.v = 38;
		sp_loading.w = 8;
		sp_loading.h = 8;

		GsSortSprite(&sp_loading, Gfx.pOT, 0); 
	}	
	EndFrame();

}


void dotitlescreen(){
	int loop = 1, go = 0;
	sp_title.r=0;
	sp_title.g=0;
	sp_title.b=0;
	sp_title.x = SCNW/2 - sp_title.w/2;
	sp_title.y = SCNH/2 - sp_title.h/2;

	
	do{
		GetPadData(0, &Pad0);
		GetPadData(1, &Pad1);

		if (loop == 1){
			if (sp_title.r<128){
				sp_title.r+=2;
				sp_title.g = sp_title.r;
				sp_title.b = sp_title.r;
			}
		}
		
		if (loop == 2){
			if (sp_title.r>0){
				sp_title.r-=2;
				sp_title.g = sp_title.r;
				sp_title.b = sp_title.r;
			}
		}
		
		if (sp_title.r <=0){
			if (go == 1){
				gamestate = 2;
				return;		
				}	
			if (go == 2)
				go = 3;
		}				
	
		if(Pad0.State & PadStart){
			loop = 2;
			go = 1;			
		}
		if(Pad0.State & PadCircle){
			loop = 2;
			go = 2;
		}
		if(Pad0.State & PadCross){
			loop = 1;
			go = 0;
		}
		
		if(Pad1.State & PadCircle){		//tile appear rush
			tile_appear_style = 2;
		}
		if(Pad1.State & PadTriangle){		//tile appear slide
			tile_appear_style = 1;
		}
		if(Pad1.State & PadSquare){		//tile appear normal
			tile_appear_style = 0;
		}
	
		if (tile_appear_style != 0)		FntPrint(Gfx.FntID, "~c090%d",tile_appear_style);
		
	
	
		StartFrame(); 
			if (go == 3){
				FntPrint(Gfx.FntID, "\n~c090: ivy");
				FntPrint(Gfx.FntID, "\n\n~c090: a shooting game for 2 players");
				FntPrint(Gfx.FntID, "\n~c090: --------------------------------------");
				FntPrint(Gfx.FntID, "\n\n~c090: event : ca221 coursework 1");
				FntPrint(Gfx.FntID, "\n~c090: method: chris mclaughlin <0102502>");				
				FntPrint(Gfx.FntID, "\n~c090: --------------------------------------");

				FntPrint(Gfx.FntID, "\n\n~c090: controls :");
				FntPrint(Gfx.FntID, "\n~c090:    d-pad - player movement");			
				FntPrint(Gfx.FntID, "\n~c090: triangle - fire up");
				FntPrint(Gfx.FntID, "\n~c090:   square - fire left");
				FntPrint(Gfx.FntID, "\n~c090:   circle - fire right");
				FntPrint(Gfx.FntID, "\n~c090:    cross - fire down");
				FntPrint(Gfx.FntID, "\n\n~c090:       L1 - focus on player 1");
				FntPrint(Gfx.FntID, "\n~c090:       L2 - focus on player 2");
				
				FntPrint(Gfx.FntID, "\n~c090:   select - end");
				FntPrint(Gfx.FntID, "\n\n\n~c090: press x to return to title screen");

				}
		
				else{	
					GsSortSprite(&sp_title, Gfx.pOT, 0);
				}
		EndFrame();
	}while(loop != 0);

}

void delay(int time){
int wastetime = 3;
int i;
	for(i = 0; i<time; i++){
		wastetime = (wastetime + 3 * wastetime + 4*wastetime) / 7;
	}
}
void ammoout(player *p1, player *p2, tile map[][PLAYHEIGHT]){
	int ao=1;
			
	do{
		ao++;
		FntPrint(Gfx.FntID, "~c000\n\n\n\n\n\n\n\n\n\n\n\t\t\t ::no ammo!::");		
		
		DrawFrame(p1, p2, map, &sp_floor); 
	}while(ao <= 65);

	initplayers(p1, p2);
	p1->ammo = 200;
	p2->ammo = 200;
	return;



}

void endgame(){
	int waiting=1;
			
	do{
		GetPadData(0, &Pad0);
		GetPadData(1, &Pad1);
		if(Pad0.State & PadStart){
			return;
		}
		if(Pad1.State & PadStart){;
			return;
		}
		EndFrame();
		StartFrame();
			FntPrint(Gfx.FntID, "~c090\n\n\n\n\n\t\t   ::game end::");
			FntPrint(Gfx.FntID, "~c090\n\n\n\n\n\t  press start to continue");
		EndFrame();
	}while(waiting == 1);

}
void paused(player *p1, player *p2, tile map[][PLAYHEIGHT]){
	int pause=1;
			
	do{
		GetPadData(0, &Pad0);
		GetPadData(1, &Pad1);
		if(Pad0.State & PadStart){
			return;
		}
		if(Pad1.State & PadStart){;
			return;
		}
		
		FntPrint(Gfx.FntID, "~c000\n\n\n\n\n\t\t\t  ::pause::");
		DrawFrame(p1, p2, map, &sp_floor); 
	}while(pause == 1);
}

void splashme(){
int fspeed = 2, timer = 0;


sp_splash.b = 0;
sp_splash.g = 0;
sp_splash.r = 0;
sp_splash.x = SCNW/2-35;
sp_splash.y = SCNH/2-40;
sp_splash.h = 80;
sp_splash.w = 70;
sp_splash.v = 20;
	do{
		if(timer < 200){	// fade in elf		
			if (sp_splash.r <80){
				sp_splash.r += fspeed;
				sp_splash.g += fspeed;
				sp_splash.b += fspeed;
			}
		}
		if((timer >= 200) && (timer < 300)){	// fade out elf		
			if (sp_splash.r >0){
				sp_splash.r -= fspeed;
				sp_splash.g -= fspeed;
				sp_splash.b -= fspeed;
			}
		}
		if((timer >= 300) && (timer < 500)){	// fade in 0102502	
		sp_splash.x = SCNW/2-50;
		sp_splash.y = SCNH/2-10;
		sp_splash.h = 20;
		sp_splash.w = 100;
		sp_splash.v = 0;
			if (sp_splash.r <100){
				sp_splash.r += fspeed;
				sp_splash.g += fspeed;
				sp_splash.b += fspeed;
			}
		}
		if((timer >= 500) && (timer < 650)){	// fade out 0102502		
			if (sp_splash.r >0){
				sp_splash.r -= fspeed;
				sp_splash.g -= fspeed;
				sp_splash.b -= fspeed;
			}
		}
	
		StartFrame(); 
		//FntPrint(Gfx.FntID, "~c090rgb: %d\ntmr: %d",sp_splash.r, timer);
		GsSortSprite(&sp_splash, Gfx.pOT, 0);				
		EndFrame();
	
		timer++;
	}while(timer < 650 );
}