#include "collision.h"

// =======================================================================================
// check what direction a collision is occuring in [bounding box] ========================
int bbox_collision_dir(S_entity *a, S_entity *b){

		if ( (a->y <= (b->y + b->sprite->h) ) && ( (a->y + a->sprite->h) > (b->y + b->sprite->h)))	//intersects bottom
			return 1;
		if ((a->y < b->y) && ((a->y + a->sprite->h) >= b->y))						//intersects top
			return 4;
		if ((a->x < b->x) && ((a->x + a->sprite->w) >= b->x ))						//intersects left
			return 2;
		if ((a->x <= (b->x + b->sprite->w)) && ((a->x + a->sprite->w) > (b->x + b->sprite->w)))		//intersects right
			return 3;

	return 0;
}


// =======================================================================================
// collision between two entities [bounding box] =========================================
int bbox_collision(S_entity *a, S_entity *b){

if(!(((a->x + a->sprite->w) <= b->x) 	|| 
	(a->x >= (b->x + b->sprite->w)) 	|| 
	((a->y + a->sprite->h) <= b->y)  	|| 
	(a->y >= (b->y + b->sprite->h)) ))	
	return 1;

else 	
	return 0;

}



// =======================================================================================
// check for collision with ground =======================================================
int CollideWithGround(S_actor *thisactor){


	int ontile_x, ontile_y, x; 
	int c_in, c_on, c_on_r, c_over;
	extern tile tilelist[64];
	extern int level_1[LEVELDY][LEVELDX];
	extern int collisionmap[15][TILESCALE];
	
	
	if(thisactor->object.entity.y>0){//do if on screen
		ontile_x = (thisactor->object.entity.x+thisactor->object.hillx) / TILESCALE;
		ontile_y = (thisactor->object.entity.y+thisactor->object.hilly) / TILESCALE;
		c_in 	= tilelist[level_1[ontile_y][ontile_x]].collide;		//in(for tiles)
		c_over 	= tilelist[level_1[ontile_y+1][ontile_x]].collide;		//in(for tiles)
		
		if (thisactor->object.yvel > 0){
		//------------------------------------------------------------------------------non flat tile -----------------
			if (c_in>=1){
					x=((thisactor->object.entity.x+thisactor->object.hillx) - 16*ontile_x);
												
				if (thisactor->object.entity.y >= (16*ontile_y)+(collisionmap[c_in-1][x])-thisactor->h){	// if colliding with ground			
					thisactor->object.entity.y = (16*ontile_y)+(collisionmap[c_in-1][x])-thisactor->h;
					thisactor->jumping 	= 0;					//set jumping and yvel to 0
					thisactor->object.yvel = 0;
				}
			}		
			
		//--------------------------------------------------------------------------------- flat tile -----------------	
			else{
				ontile_x = (thisactor->object.entity.x) / TILESCALE;
				ontile_y = (thisactor->object.entity.y + thisactor->h) / TILESCALE;	
				c_on 	= tilelist[level_1[ontile_y][ontile_x]].collide;		//on	
				c_on_r 	= tilelist[level_1[ontile_y][ontile_x+1]].collide;		//onright
					
				if ( (c_on == 1) || (c_on_r == 1) || (c_on == 2)){				//flat tiles
					thisactor->object.entity.y = ontile_y*16-thisactor->h;		//sit on tile
					thisactor->jumping = 0;										//set jumping and yvel to 0
					thisactor->object.yvel = 0;
				}
			}
		}	
	}
}



// =======================================================================================
// check for collision with walls ========================================================
int CollideWithWalls(S_actor *thisactor){
	extern tile tilelist[64];
	extern int level_1[LEVELDY][LEVELDX];
	extern int collisionmap[15][TILESCALE];
	int ontile_x, ontile_y, c_on, c_right, c_left; 

	if(thisactor->object.entity.y>0){//do if on screen
		ontile_x = (thisactor->object.entity.x) / TILESCALE;
		ontile_y = ((thisactor->object.entity.y + thisactor->h) / TILESCALE) -1;	
				
		c_left 	= tilelist[level_1[ontile_y][ontile_x-1]].collide;
		c_on 	= tilelist[level_1[ontile_y][ontile_x]].collide;
		c_right = tilelist[level_1[ontile_y][ontile_x+1]].collide;
		
		//FntPrint(Gfx.FntID,"~c000\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\t\t[%d][%d][%d]",tilelist[level_1[ontile_y-1][ontile_x-1]].collide,tilelist[level_1[ontile_y-1][ontile_x]].collide,tilelist[level_1[ontile_y-1][ontile_x+1]].collide);
		//FntPrint(Gfx.FntID,						   "~c000\n\t\t[%d][%d][%d]",tilelist[level_1[ontile_y][ontile_x-1]].collide,tilelist[level_1[ontile_y][ontile_x]].collide,tilelist[level_1[ontile_y][ontile_x+1]].collide);
		//FntPrint(Gfx.FntID,						 "~c000\n\t\t[%d][%d][%d]\n",tilelist[level_1[ontile_y+1][ontile_x-1]].collide,tilelist[level_1[ontile_y+1][ontile_x]].collide,tilelist[level_1[ontile_y+1][ontile_x+1]].collide);
		
		if(c_right == 99){
			if (thisactor->object.xvel >= 0)
				thisactor->object.entity.x = ontile_x*16;
				FntPrint(Gfx.FntID,"~c000\nR\n");
		}
		
		if(c_on == 99){
				if (thisactor->object.xvel <= 0)
				thisactor->object.entity.x = (ontile_x+1)*16;
				FntPrint(Gfx.FntID,"~c000\nL\n");
		}
	}
}
