#include "draw_more.h"

// ============================== change overall colour of layer ================================
void colourlayer(drawlayer *layer, int speed){
	if (speed == 0 ){
		layer->dr = layer->r;
		layer->dg = layer->g;
		layer->db = layer->b;
	}
	else{
					if (layer->dr < layer->r) layer->dr += speed;
			else 	if (layer->dr > layer->r) layer->dr -= speed;
	
					if (layer->dg < layer->g) layer->dg += speed;
			else 	if (layer->dg > layer->g) layer->dg -= speed;
			
					if (layer->db < layer->b) layer->db += speed;
			else 	if (layer->db < layer->b) layer->db -= speed;
	}
}



// ============================== draw collected flowers ================================
void DrawDiscoLoveFlowers(void){
	extern S_player aapj;
	extern GsSPRITE sp_collectable;
	extern S_collectable DiscoLoveFlower[10];
	int i;

		for( i = 0; i<10; i++){
			
			if (DiscoLoveFlower[i].collected == 1){			
				DiscoLoveFlower[i].entity.frame+=2;	
				sp_collectable.r = 128;
				sp_collectable.g = 128;
				sp_collectable.b = 128;
			}
				
			else{
				sp_collectable.r = 16;
				sp_collectable.g = 16;
				sp_collectable.b = 16;
			}	
				sp_collectable.x = 32+(i*16);
				sp_collectable.y = SCNH - 24;
				sp_collectable.u = ((DiscoLoveFlower[i].entity.frame>>3)%4)*16;;
				sp_collectable.v = 16;
				GsSortSprite(&sp_collectable, Gfx.pOT, 0);			
		}
		
	sp_collectable.r = 128;
	sp_collectable.g = 128;
	sp_collectable.b = 128;
}


// ============================== draw yasmins tail if playing ================================
void DrawTail(void){	
	extern S_player aapj;
	extern GsSPRITE sp_tail;
	extern drawlayer lyr_0_main;
	int i;
	
		for (i = 0; i<9; i++){
			if (aapj.oldpos[i].y <= aapj.actor.object.entity.y+16)
				aapj.oldpos[i].y+=(aapj.actor.object.entity.y+24 - aapj.oldpos[i].y)/8;
			sp_tail.x = aapj.oldpos[i].x + lyr_0_main.layerx;
			sp_tail.y = aapj.oldpos[i].y + lyr_0_main.layery;
			sp_tail.u = 32*(i%2);
			sp_tail.v = 0;
			GsSortSprite(&sp_tail, Gfx.pOT, 0);
		}

		for (i = 0; i<9; i++){
			sp_tail.x = aapj.oldpos[i].x + lyr_0_main.layerx;
			sp_tail.y = aapj.oldpos[i].y + lyr_0_main.layery;
			sp_tail.u = 16+32*(i%2);
			sp_tail.v = 0;
			GsSortSprite(&sp_tail, Gfx.pOT, 0);
		}
}

// =======================================================================================
// draw an entity =========================================================================

void drawentity(S_entity *todraw, int dir){		//0=l to r, 1 = r to l
	extern drawlayer lyr_0_main;
	int fr;
	if (dir){
		todraw->sprite->scalex = -ONE;
	}
	else
		todraw->sprite->scalex = ONE;

	fr = ((todraw->frame>>3)%4);
	todraw->sprite->u = fr*todraw->sprite->w;
	
	todraw->sprite->x = todraw->x+lyr_0_main.layerx + todraw->sprite->mx;
	todraw->sprite->y = todraw->y+lyr_0_main.layery + todraw->sprite->my;

	GsSortSprite(todraw->sprite, Gfx.pOT, 0);
}



// ============================== draw main menu ================================
int DrawMenu(void){
extern GsSPRITE sp_titlebar;
extern GsSPRITE sp_title1;
extern GsSPRITE sp_title2;

	StartFrame();	
	GsSortSprite(&sp_titlebar, Gfx.pOT, 0);	
	GsSortSprite(&sp_title1, Gfx.pOT, 0);
	GsSortSprite(&sp_title2, Gfx.pOT, 0);
	EndFrame();	
}

int DrawOptionMenu(int selection, int vol){
extern GsSPRITE sp_titlebar;
extern GsSPRITE sp_title1;
extern GsSPRITE sp_title2;

StartFrame();	
	// setup for selection display ==============================================
	sp_titlebar.w 		= 48;		sp_titlebar.h 		= 12;
	sp_titlebar.u 		= 208;		sp_titlebar.v 		= 12+(12*selection);
	sp_titlebar.scalex 	= 4096 * 5;	sp_titlebar.scaley 	= 4096 * 5;				
	GsSortSprite(&sp_titlebar, Gfx.pOT, 0);	
	//===========================================================================
	
	// setup for volume display =================================================
	sp_titlebar.w 		= 64;			sp_titlebar.h 		= 12;
	sp_titlebar.u 		= 32+(vol*16);	sp_titlebar.v 		= 60;		
	GsSortSprite(&sp_titlebar, Gfx.pOT, 0);	
	//===========================================================================
	GsSortSprite(&sp_title1, Gfx.pOT, 0);
	GsSortSprite(&sp_title2, Gfx.pOT, 0);
	EndFrame();	
}
// =======================================================================================
// draw sun ==============================================================================

void drawsun(void){
extern GsSPRITE sp_sun;
extern drawlayer lyr_sun;

	if (sp_sun.w !=0){
		colourlayer(&lyr_sun, 5);
		sp_sun.r = lyr_sun.dr;		
		sp_sun.g = lyr_sun.dg;		
		sp_sun.b = lyr_sun.db;
		sp_sun.rotate += 512;
		GsSortSprite(&sp_sun, Gfx.pOT, 0);
		
	}
}

// =======================================================================================
// show how much has been loaded =========================================================
//text  MUST be 12 chars long
void loadprogress(int stage, int numstages, char *text){
	int i;
	char dstring[20];
	extern GsSPRITE sp_font;

	strcpy(dstring,"```````````````            ``");	
	strcat(dstring, text);
	strcat(dstring,"``            ```````````````");
	
	StartFrame(); 		
	drawText(SCNW/2-64,64, dstring, 14);		

	strcpy(dstring,"`");
	for(i=0;i<stage;i++)
		strcat(dstring,"`");
		
	for(i=0;i<(numstages-stage);i++)
		strcat(dstring, "{");

	strcat(dstring, "`");

	drawText(SCNW/2-(((numstages+3)*8)/2),160,dstring, numstages+2);		

	EndFrame();

}