//**************Henry S Fortuna July-2001*********

#include <libps.h>
#include "defines.h"
#include "structures.h"
#include "globals.h"
#include "graphics.h"



// Initialise the PSX graphics  system***************
void InitGfx(void)
{
	SetVideoMode(MODE_PAL);                     
	GsInitGraph(SCNW,SCNH,4,0,0);
	GsDefDispBuff(0,0,0,SCNH);
	Gfx.ot[0].length = OTLEN;                      
	Gfx.ot[0].org = Gfx.ottags[0];
	Gfx.ot[1].length = OTLEN;                      
	Gfx.ot[1].org = Gfx.ottags[1];
}//initGfx

//Load fonts into VRAM ******************************
int LoadFont(void)
{
	FntLoad(960,256);                           
	return (FntOpen(16,16,SCNW,SCNH,0,512));
}//loadfont

//prepare frame *************************************
// Function initialises the ordering tables for the start of a new frame.
void StartFrame(void)
{
	Gfx.buf = GsGetActiveBuff();
	Gfx.pOT = &Gfx.ot[Gfx.buf];
	GsSetWorkBase((PACKET*)Gfx.gpuPktArea[Gfx.buf]);                   
	GsClearOt(0,0,Gfx.pOT);   
}//StartFrame

//do actual drawing *********************************
// Function concludes rendering of the current frame by sending the current
// ordering table to the GPU (synchronised with the VSync interrupt).
void EndFrame()
{	
	//int mysync;
	FntFlush(-1);
	DrawSync(0);                      
	//mysync = 
	VSync(0);
	//if (!DEBUG) { FntPrint(Gfx.FntID, "sync: %d\n",mysync); }
	GsSwapDispBuff();
	GsSortClear(220,220,225,Gfx.pOT);  //Background rgb           
	GsDrawOt(Gfx.pOT);
	
}//EndFrame           
