#include "base.h"
#include "init.h"
#include <stdio.h>
#include <__rts_info_t__.h>

//tile tilelist[64];
//drawlayer lyr_0_main;


GsSPRITE sp_level;
GsSPRITE sp_player;
GsSPRITE sp_enemy;
GsSPRITE sp_collectable;
GsSPRITE sp_sun;
GsSPRITE sp_titlebar;
GsSPRITE sp_overlay;
GsSPRITE sp_BG_0;
GsSPRITE sp_tail;
GsSPRITE sp_font;
GsSPRITE sp_projectile;
GsSPRITE sp_title1;
GsSPRITE sp_title2;

voice_data 	playerjump, 
			playerdie,
			powerdown,
			life_up,
			swish,
			vlife,
			vinyl1,
			vinyl2,
			vinyl3
			;

int whatPlayer = 0, level = 1, sfxvol=127, musicvol = 100;
int projectlist[NOPROJ];

S_collectable DiscoLoveFlower[10];
S_collectable otherCollect[32];
S_collectable vinyl[200];

drawlayer lyr_0_main;
drawlayer lyr_bg0;
drawlayer lyr_sun;
tile tilelist[144];

int bg01[LEVELDY/4][LEVELDX/4];
tile bg01tilelist[16];

char displaystring[256];

int (* DoState)(void);
int GameOver(void);
int LevelStart(void);
int GameEnd(void);

S_player aapj;
S_enemy badguy[NOENEMY+1];
int collisionmap[23][TILESCALE] = {
//flat= 

{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},					//flat ground			1
{15,15,14,14,13,13,12,12,11,11,10,10,9,9,8,8},		//slope30lower 	l		2
{7,7,6,6,5,5,4,4,3,3,2,2,1,1,0,0},					//slope30upper 	l		3
{8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,15},		//slope30lower 	r		4
{0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7},					//slope30upper 	r		5

{15,14,13,12,11,10,9,8,7,6,5,4,3,2,1},				//slope45		l		6
{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},				//slope45		r		7

{0,0,1,1,1,1,1,2,2,2,2,3,3,3,4,4},					//uneven ground			8
{4,4,4,4,4,4,4,5,5,5,5,5,5,5,4,4},					//uneven ground			9
{4,4,4,4,3,3,3,3,3,3,3,4,4,4,4,4},					//uneven ground			10
{4,4,4,4,3,3,3,3,2,2,2,2,1,1,1,1},					//uneven ground			11
{0,0,1,1,2,2,2,2,2,2,2,2,1,1,0,0},					//uneven ground			12
{0,0,0,0,1,1,2,2,3,3,4,4,4,4,4,4},					//uneven ground			13
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},					//uneven ground			14


{0,1,1,1,1,1,1,2,2,2,2,3,3,4,4,4},					//slope right upper		15
{5,5,6,6,7,7,8,8,9,10,10,11,12,13,14,15},			//slope right lower		16
{15,14,13,12,11,10,10,9,8,8,7,7,6,6,5,5},			//slope left lower		17
{4,4,4,3,3,2,2,2,2,1,1,1,1,1,1,0},					//slope left upper		18

{0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11}, 				//slope up left upper	19
{12,12,12,13,13,14,14,14,14,15,15,15,15,15,15,16}, 	//slope up left lower	20
{16,15,15,15,15,15,15,14,14,14,14,13,13,12,12,12}, 	//slope up right upper	21
{11,11,10,10,9,9,8,8,7,6,5,4,3,2,1,0}, 				//slope up right lower	22
};


void InitialiseHeap(void)
{
	// heap starts after the main program on a 16-byte boundary
	unsigned long	lclHeapStart=(_end & 0xFFFFFFF0L)+0x10;

	// heap extends to the bottom of the stack.
	unsigned long lclHeapSize=((_stack_addr-(_stack_size<<10)) & 0xFFFFFFF0L)-lclHeapStart;

	InitHeap((unsigned long *)lclHeapStart, lclHeapSize);

}

int level_1[LEVELDY][LEVELDX];


void buildmaplookup(void){
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[200];
	
int index = 0;
		while(index<143){
			tilelist[index].u = (index%12)*16;
			tilelist[index].v = (index/12)*16;
			tilelist[index].rotate = 0;	
			tilelist[index].friction = 1;	
			tilelist[index].collide = 0;

			if (index<15){
				bg01tilelist[index].u =  (index%4)*32;
				bg01tilelist[index].v =  (index/4)*32;
			}
			index++;
		};

		tilelist[2].collide = 
		tilelist[8].collide = 
		tilelist[9].collide = 		
		tilelist[10].collide =  
		tilelist[36].collide = 
		tilelist[37].collide = 
		tilelist[38].collide = 
		tilelist[39].collide = 
		tilelist[40].collide = 
		tilelist[41].collide = 
		tilelist[42].collide = 
		tilelist[43].collide = 
		tilelist[44].collide = 
		tilelist[45].collide = 
		tilelist[46].collide = 
		tilelist[47].collide = 
		tilelist[60].collide = 
		tilelist[61].collide = 
		tilelist[62].collide = 
		tilelist[63].collide = 
		tilelist[70].collide =
		tilelist[71].collide = 1;	//flat ground
		
		
		tilelist[82].collide =
		tilelist[83].collide =
		tilelist[94].collide =
		tilelist[95].collide = 99;	//walls
		
 
		tilelist[12].collide = 5;	//30degree
		tilelist[13].collide = 4;
		tilelist[14].collide = 2;
		tilelist[15].collide = 3;		
		
		tilelist[24].collide = 5;
		tilelist[25].collide = 4;
		tilelist[26].collide = 2;
		tilelist[27].collide = 3;
		
		tilelist[48].collide = 7;	//45degree
		tilelist[49].collide = 6;
		
		tilelist[50].collide = 7;
		tilelist[51].collide = 6;		
		
		tilelist[72].collide = 15;	//transitions
		tilelist[73].collide = 16;
		tilelist[74].collide = 17;
		tilelist[75].collide = 18;
		tilelist[84].collide = 15;	
		tilelist[85].collide = 16;
		tilelist[86].collide = 17;
		tilelist[87].collide = 18;
		
		tilelist[96].collide = 19;
		tilelist[97].collide = 20;
		tilelist[98].collide = 21;
		tilelist[99].collide = 22;		
		tilelist[108].collide = 19;
		tilelist[109].collide = 20;
		tilelist[110].collide = 21;
		tilelist[111].collide = 22;
		
		tilelist[16].collide = 8;	//squiggly ground
		tilelist[17].collide = 9;
		tilelist[18].collide = 10;
		tilelist[19].collide = 11;
		tilelist[20].collide = 12;
		tilelist[21].collide = 13;
		tilelist[22].collide = 14;
		
		tilelist[28].collide = 8;
		tilelist[29].collide = 9;
		tilelist[30].collide = 10;
		tilelist[31].collide = 11;
		tilelist[32].collide = 12;
		tilelist[33].collide = 13;
		tilelist[34].collide = 14;
		
		
		tilelist[23].collide = 98;	//restart
		tilelist[35].collide = 99;	//end
		
		
	for ( index = 0; index<10; index++){
	
		DiscoLoveFlower[index].entity.x 	= -16;//index*64+32;
		DiscoLoveFlower[index].entity.y 	= -16;
		DiscoLoveFlower[index].entity.frame = 0;		
		DiscoLoveFlower[index].entity.anim  = 0;
		
		DiscoLoveFlower[index].type = 1;		
		DiscoLoveFlower[index].score = 1000;	
		DiscoLoveFlower[index].collected = 1;	
		
		
		DiscoLoveFlower[index].entity.sprite->w = 16;
		DiscoLoveFlower[index].entity.sprite->h = 16;
		
	}	
	
	for ( index = 0; index<200; index++){
	
		vinyl[index].entity.x 		= -16;
		vinyl[index].entity.y 		= -16;		
		vinyl[index].entity.frame 	= 0;		
		vinyl[index].entity.anim  	= 0;
		
		vinyl[index].type 			= 0;		
		vinyl[index].score 			= 100;	
		vinyl[index].collected 		= 1;	
		
		
		vinyl[index].entity.sprite->w = 16;
		vinyl[index].entity.sprite->h = 16;
		
	}
	
	for ( index = 0; index<32; index++){
	
		otherCollect[index].entity.x = -16;
		otherCollect[index].entity.y = -16;
		otherCollect[index].entity.frame = 0;		
		otherCollect[index].entity.anim  = 0;
		
		otherCollect[index].type = 0;		
		otherCollect[index].score = 0;	
		otherCollect[index].collected = 1;	
		
		
		otherCollect[index].entity.sprite->w = 16;
		otherCollect[index].entity.sprite->h = 16;
		
	}
	

	strcpy(displaystring, "");

}

void InitLayers(void){
int x,y;

	lyr_0_main.layerx 	= 0;
	lyr_0_main.layery 	= 0;	
	lyr_0_main.r 		= 128;	
	lyr_0_main.g 		= 128;
	lyr_0_main.b 		= 128;
	lyr_0_main.dr 		= 128;
	lyr_0_main.dg 		= 128;
	lyr_0_main.db		= 128;	
	
	lyr_bg0.layerx	= 0;
	lyr_bg0.layery	= 0;	
	lyr_bg0.r 		= 128;	
	lyr_bg0.g 		= 128;
	lyr_bg0.b 		= 128;
	lyr_bg0.dr 		= 128;
	lyr_bg0.dg 		= 128;
	lyr_bg0.db		= 128;
	
	lyr_sun.layerx 	= 0;
	lyr_sun.layery 	= 0;	
	lyr_sun.r 		= 128;	
	lyr_sun.g 		= 128;
	lyr_sun.b 		= 128;
	lyr_sun.dr 		= 128;
	lyr_sun.dg 		= 128;
	lyr_sun.db		= 128;
	
	
	
	for (y=0; y< LEVELDY/4; y++){
		for (x=0; x< LEVELDX/4; x++){
			bg01[y][x] = rand()%16;
		}
		bg01[y][0] = 3;
	}
}

void ResetPlayer(S_player *theplayer){
int i;
	theplayer->actor.object.entity.x	= 64;
	theplayer->actor.object.entity.y	= 64;
	theplayer->actor.object.entity.frame= 0;
	theplayer->actor.object.entity.anim	= 0;

	
	theplayer->actor.object.hillx		= 8;
	theplayer->actor.object.hilly		= 31;	
	theplayer->actor.object.xvel		= 0;
	theplayer->actor.object.yvel		= 0;	
	theplayer->actor.object.maxspeed	= 3;	
	
	theplayer->actor.maxjump			= -6;
	theplayer->actor.jumping			= 0;
		
	theplayer->actor.w					= 16;
	theplayer->actor.h					= 32;
	theplayer->actor.health 			= 1;

	for (i = 0; i <9; i++){		
		theplayer->oldpos[i].x 			= theplayer->actor.object.entity.x;
		theplayer->oldpos[i].y 			= theplayer->actor.object.entity.y;
	}
	
	theplayer->basev					= 0;
	theplayer->old_at					= 0;
	theplayer->basepower				= 0;
	theplayer->timepower				= 0;
	theplayer->infotime					= 0;
	theplayer->actor.lastpos.x 			= 0;
	theplayer->actor.lastpos.y 			= 0;

	theplayer->actor.oldcollision		= 0;
	theplayer->actor.newcollision		= 0;


}

void initplayer(S_player *theplayer){
	
	ResetPlayer(theplayer);
	theplayer->actor.object.entity.sprite = &sp_player;

	
	theplayer->score 					= 0;
	theplayer->discolove				= 0;
	theplayer->showmydiscolove			= 0;	
	theplayer->records 					= 3;	
	theplayer->lives 					= 3;	
}



void initenemy(S_enemy *badguy, int x, int y, int type){

	badguy->actor.object.entity.sprite = &sp_enemy;
	badguy->actor.object.entity.sprite->scaley = 4096;
	
	badguy->actor.object.entity.x		= 16+64*rand()%16;
	badguy->actor.object.entity.y		= -16;
	badguy->actor.object.entity.frame	= 0;
	badguy->actor.object.entity.anim	= 0;

	
	badguy->actor.object.hillx			= 8;
	badguy->actor.object.hilly			= 15;	
	do{
		badguy->actor.object.xvel		= 1-rand()%2;
	}while (badguy->actor.object.xvel == 0);
	
	badguy->actor.object.yvel			= 0;	
	badguy->actor.object.maxspeed		= 3;
		
	badguy->actor.w						= 16;
	badguy->actor.h						= 16;
	badguy->actor.health 				= 1;
	badguy->actor.maxjump				= 0;
	badguy->actor.jumping				= 0;	
	
	
	badguy->type 						= type;
	badguy->aware 						= 1;
	badguy->aggressive 					= 0;
	badguy->provoked 					= 0;
	badguy->score 						= 100;



}