/*******************************************/
/* Reading the control pad buffers - pad.h */
/*******************************************/

#ifndef _PAD_H_
#define _PAD_H_

#define PadUp        (1<<12)
#define PadDown      (1<<14)
#define PadLeft      (1<<15)
#define PadRight     (1<<13)
#define PadTriangle  (1<<4)
#define PadCross     (1<<6)
#define PadSquare    (1<<7)
#define PadCircle    (1<<5)
#define PadStart     (1<<11)
#define PadSelect    (1<<8)
#define PadL1        (1<<2)
#define PadL2        (1<<0)
#define PadL3        (1<<9)       //analogue pushbutton
#define PadR1        (1<<3)
#define PadR2        (1<<1)
#define PadR3        (1<<10)      //analogue pushbutton

#define PadIn   	 (0x00)
#define PadOut  	 (0xff)

#define PadStandard  (0x4)
#define PadAnalogue  (0x5)
#define PadDualShock (0x7)

void InitPads(void);
int PadConnected(int port);
int PadType(int port);
int PadState(int port);
int PadLHorz(int port);   //L analogue X value
int PadLVert(int port);   //L analogue Y value
int PadRHorz(int port);   //R analogue X value
int PadRVert(int port);   //R analogue Y value

//Horz analogue values: 0 left, 255 right
//Vert analogue values: 0 up, 255 down

#endif 
