//=============================================================================================================
// Action Afro Pj 
//-------------------------------------------------------------------------------------------------------------
//
// main file for AAPJ playstation tile based game, includes main() and game loop.
//
//=============================================================================================================

#define GLOBAL_OWNERSHIP
	 
#include "base.h" 
#include "graphics.h"
#include "pad.h"
#include "init.h"
#include "draw.h"
#include "sound.h"
#include <stdlib.h>
#include "MWDebugIO.h"


//extern int (* DoState)(void);

int TitleScreen(void);
int MainGame(void);
int MainMenu(void);
int Paused(void);
int PlayerSelect(void);
int OptionsMenu(void);
int Credits(void);
int Help(void);

int GetUserInput();



void main(){
extern S_player aapj;
extern S_enemy badguy[NOENEMY+1];
int i;

// sound effects ---------------------------------------------------------------------- 
//short seq_id;					      // seq id number 0-32 
//static unsigned char vs[20*1024];

short vab_id;				           		// vab id number 0-15
static unsigned char vh[5*1024];            // buffer for sound header
static unsigned char vb[160*1024];          // buffer for sound body	
extern voice_data 	playerjump, 	playerdie,		powerdown,		life_up,
					swish,			vlife,			vinyl1,			vinyl2,
					vinyl3;
//----------------------------------------------------------------------
  
InitialiseHeap();
InitGfx();
InitPads();
InitLayers();
buildmaplookup();
initplayer(&aapj);

for(i=0;i<NOENEMY;i++)
	initenemy(&badguy[i],  16,16,0);

Gfx.FntID = LoadFont();
	StartFrame();
	EndFrame();	
	
	//loadprogress(8, LOADSTAGES, "title screen");
	if(!ConfigureSprite(&sp_font, 		"gfx/font.tim", 10, 10))
	{ResetGraph(3);	return;}	
	sp_font.x = 8; sp_font.y = 8; sp_font.w = 8; sp_font.h = 8;	
	loadprogress(1, LOADSTAGES, "   enemies  ");
	if(!ConfigureSprite(&sp_title1, "gfx/title1.tim", 10, 10))	
	{ResetGraph(3);	return;}
	if(!ConfigureSprite(&sp_title2, "gfx/title2.tim", 10, 10))	
	{ResetGraph(3);	return;}
	loadprogress(2, LOADSTAGES, "   tiles..  ");	
	if(!ConfigureSprite(&sp_enemy, 		"gfx/enemy.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(3, LOADSTAGES, "more tiles..");
	if(!ConfigureSprite(&sp_level, 		"gfx/level.tim", 10, 10))	
	{ResetGraph(3);	return;}
	loadprogress(4, LOADSTAGES, " powerups.. ");	
	if(!ConfigureSprite(&sp_BG_0, 		"gfx/bg01.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(5, LOADSTAGES, "  menus...  ");	
	if(!ConfigureSprite(&sp_collectable,"gfx/collect.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(6, LOADSTAGES, "    fx...   ");	
	if(!ConfigureSprite(&sp_titlebar, 	"gfx/titlebar.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(7, LOADSTAGES, "  numbers.. ");
	if(!ConfigureSprite(&sp_tail, 		"gfx/tail.tim", 10, 10))	
	{ResetGraph(3);	return;}
	loadprogress(8, LOADSTAGES, "  more fx.  ");
	if(!ConfigureSprite(&sp_overlay, 	"gfx/overlay.tim", 10, 10))	
	{ResetGraph(3);	return;}
	loadprogress(9, LOADSTAGES, " Sound FX   ");
	if(!ConfigureSprite(&sp_projectile, "gfx/projectile.tim", 10, 10))	
	{ResetGraph(3);	return;}	
	
	loadprogress(10, LOADSTAGES, "instruments ");
  	
/*  	loadprogress(11, LOADSTAGES, " disco funk ");
	MWbload("music/genmidi.vh", vh);
	MWbload("music/genmidi.vb", vb);

	loadprogress(12, LOADSTAGES, "    sfx     ");
	MWbload("music/DISCO.seq", vs);
	
	seq_id = InitMusic((unsigned long*)vs, vab_id);
 	SetupReverb();   
 	
 	PlayMusic(seq_id);
//	StopMusic(seq_id)
 	*/                              // set reverb 
 	
   	MWbload("sfx/sfx.vh", vh);
	MWbload("sfx/sfx.vb", vb);
	
	vab_id = InitSoundSys(vh,vb);
	
	InitSFX(&playerdie,	vab_id,0,0,64,0,127,127);	// initialise sound structures
  	InitSFX(&playerjump,vab_id,0,1,64,0,127,127);
  	InitSFX(&powerdown,	vab_id,0,2,64,0,127,127);
  	InitSFX(&life_up,	vab_id,0,3,64,0,127,127);
  	InitSFX(&swish,		vab_id,0,4,64,0,127,127);
  	InitSFX(&vlife,		vab_id,0,5,64,0,127,127);
  	InitSFX(&vinyl1,	vab_id,0,6,64,0,127,127);
  	InitSFX(&vinyl2,	vab_id,0,7,64,0,127,127);
  	InitSFX(&vinyl3,	vab_id,0,8,64,0,127,127);



	sp_level.x 		= 0;
	sp_level.y 		= 0;
	sp_level.w 		= 16;
	sp_level.h 		= 16;	
	
	sp_player.x 	= 100;
	sp_player.y 	= 100;
	sp_player.w 	= 16;
	sp_player.h 	= 32;	
	sp_player.mx 	= sp_player.w/2;
	
	sp_enemy.x 		= 0;
	sp_enemy.y 		= 0;
	sp_enemy.w 		= 16;
	sp_enemy.h 		= 16;
	sp_enemy.mx 	= sp_enemy.w/2;
	sp_enemy.my 	= 0;
	sp_enemy.scalex = 4096;
	sp_enemy.scaley = 4096;
	
	sp_sun.x 		= 200;
	sp_sun.y 		= 50;
	sp_sun.mx 		= sp_sun.w/2;
	sp_sun.my 		= sp_sun.h/2;
	sp_sun.scalex 	= 4096 * 6;
	sp_sun.scaley 	= 4096 * 6;
	sp_sun.w 		= 0;
	sp_sun.h 		= 0;
	
	sp_titlebar.x 		= 0;
	sp_titlebar.y 		= SCNH/4;
	sp_titlebar.w 		= 64;
	sp_titlebar.h 		= 12;
	sp_titlebar.u 		= 0;
	sp_titlebar.v 		= 0;
	sp_titlebar.scalex 	= 4096 * 5;
	sp_titlebar.scaley 	= 4096 * 5;

 	sp_overlay.w 		= 16;
	sp_overlay.h 		= 16;
	sp_overlay.x 		= 0;
	sp_overlay.y 		= 0;
	sp_overlay.u 		= 0;
	sp_overlay.v 		= 0;
	
	sp_BG_0.w 			= 32;
	sp_BG_0.h 			= 32;
	sp_BG_0.x 			= 0;
	sp_BG_0.y 			= 0;
	sp_BG_0.u 			= 0;
	sp_BG_0.v 			= 0;

	sp_collectable.w 	= 16;
	sp_collectable.h 	= 16;
	sp_collectable.x 	= 0;
	sp_collectable.y 	= 0;
	sp_collectable.u 	= 0;
	sp_collectable.v 	= 0;

	sp_tail.x 			= 0;
	sp_tail.y 			= 0;
	sp_tail.w 			= 16;
	sp_tail.h 			= 16;	

	sp_font.x 			= 8;
	sp_font.y 			= 8;
	sp_font.w 			= 8;
	sp_font.h 			= 8;
		
	sp_projectile.x 	= 0;
	sp_projectile.y 	= 0;
	sp_projectile.mx 	= 16;
	sp_projectile.my 	= 16;
	sp_projectile.w 	= 16;
	sp_projectile.h 	= 16;	


	sp_title1.x = 0;
	sp_title1.y = 0;
	sp_title1.w = 256;
	sp_title1.h = 240;
	
	sp_title2.x = 256;
	sp_title2.y = 0;
	sp_title2.w = 320-256;
	sp_title2.h = 240;

	DoState = &TitleScreen;
	do{
		DoState();
	}while(1);
	
	return;
}



int TitleScreen(void){

	GetPadData(0, &Pad0);
	if(Pad0.Press & PadStart){
		DoState = &MainMenu;
	}
	StartFrame();	
	drawText(180,220,"` Press Start `", 15);		
	GsSortSprite(&sp_title1, Gfx.pOT, 0);
	GsSortSprite(&sp_title2, Gfx.pOT, 0);
	EndFrame();		
}


int MainGame(void){
		GetUserInput();
		GameLogic();
		DrawFrame();
}

int GameEnd(void){
extern char displaystring[256];
	strcpy(displaystring,  "`````^^^^^____^^^^^``````   Congratulations!   ``````^^^^^____^^^^^``````                      ``  You have finished   `` the available levels `` register now for the ``   full experience!   ``                      ``````^^^^^____^^^^^`````");


	GetPadData(0, &Pad0);
		if(Pad0.Press & PadStart){
			strcpy(displaystring, "");
			DoState = &TitleScreen;
			}
		
	DrawFrame();
	GsSortSprite(&sp_titlebar, Gfx.pOT, 0);	

}

int GameOver(void){
extern char displaystring[256];
	strcpy(displaystring, "`````````````````````````      Game Over!      ``````````````````````````                      ``    Press start to    ``     begin again.     ``                      `````````````````````````");

		sp_titlebar.x 		= 0;		sp_titlebar.y 		= SCNH/4;
		sp_titlebar.w 		= 64;		sp_titlebar.h 		= 12;
		sp_titlebar.u 		= 64;		sp_titlebar.v 		= 0;
		sp_titlebar.scalex 	= 4096 * 5;	sp_titlebar.scaley 	= 4096 * 5;

	GetPadData(0, &Pad0);
		if(Pad0.Press & PadStart){
			strcpy(displaystring, "");
			DoState = &TitleScreen;
			}
		
	DrawFrame();
	GsSortSprite(&sp_titlebar, Gfx.pOT, 0);	

		

}

int Paused(void){
extern char displaystring[256];

	strcpy(displaystring, "_________________________     Game Paused      __________________________                      _'    Press start to    __       continue       __                      _________________________");

	GetPadData(0, &Pad0);
		if(Pad0.Press & PadStart){
			strcpy(displaystring, "");
			DoState = &MainGame;
			}
		
	DrawFrame();
	GsSortSprite(&sp_titlebar, Gfx.pOT, 0);	
}


int LevelStart(void){
extern S_player aapj;	
extern int level;
extern char displaystring[256];

sprintf(displaystring , "^^^^^^^^^^^^^^^^^^^^^^^^^       level %d        ^^^^^^^^^^^^^^^^^^^^^^^^^^                      ^^   you have %d lives   ^^                      ^^^^^^^^^^^^^^^^^^^^^^^^^", level, aapj.lives);


	GetPadData(0, &Pad0);
		if((Pad0.Press & PadStart) || (Pad0.Press & PadCross)){
			strcpy(displaystring, "");
			DoState = &MainGame;
		}
		
	DrawFrame();	
}

int MainMenu(void){
	static int selection = 0, items = 3;


	GetPadData(0, &Pad0);
	
	if((Pad0.Press & PadRight)	&& (selection<items))	{ selection++; }
	if((Pad0.Press & PadLeft) 	&& (selection>0))		{ selection--; }
	if(Pad0.Press & PadCross){
		PlaySFX(&swish);
		do{
			sp_titlebar.y += ( (SCNH+16) - sp_titlebar.y) / 4;
			DrawMenu();
		}while(sp_titlebar.y <= SCNH);

		switch(selection){
			case 0:					// -------------------------------------  play 			
				sp_titlebar.x = SCNW;			sp_titlebar.y = 0;
				sp_titlebar.w = 32;				sp_titlebar.h = 64;
				sp_titlebar.u = 0;				sp_titlebar.v = 12;
				sp_titlebar.scalex= 15360;		sp_titlebar.scaley= 15360;
				do{
					sp_titlebar.x -= ( sp_titlebar.x - (SCNW/4-16)) / 4;
					DrawMenu();
				}while(sp_titlebar.x >= SCNW/4);
				
				DoState = &PlayerSelect;
				break;
			case 1:					// -------------------------------------  option 				
				sp_titlebar.x 		= 0;
				sp_titlebar.y 		= SCNH;
				do{				
					sp_titlebar.y -= (sp_titlebar.y-((SCNH/4)-8)) / 4;						
					DrawOptionMenu(0,sfxvol);
				}while(sp_titlebar.y >= (SCNH/4));
	
	
				DoState = &OptionsMenu;
				break;
			case 2:					// -------------------------------------  credits 
				sp_titlebar.x = -48;		sp_titlebar.y = 0;
				sp_titlebar.w = 48;			sp_titlebar.h = 128;
				sp_titlebar.u = 32;			sp_titlebar.v = 12;
				sp_titlebar.scalex= 7680;	sp_titlebar.scaley= 7680;
				
				do{
					sp_titlebar.x += (184 - sp_titlebar.x) / 4;
					DrawMenu();
				}while(sp_titlebar.x <= 180);

				sp_titlebar.y =180;
				DoState = &Credits;
				break;
			case 3:					// -------------------------------------  help 	
				sp_titlebar.x = 0;			sp_titlebar.y = -32;
				sp_titlebar.w = 128;		sp_titlebar.h = 32;
				sp_titlebar.u = 80;			sp_titlebar.v = 12;
				sp_titlebar.scalex= 10240;	sp_titlebar.scaley= 10240;
				
				do{
					sp_titlebar.y += (118 - sp_titlebar.y) / 4;
					DrawMenu();
				}while(sp_titlebar.y <= 110);

				sp_titlebar.y =110;
				DoState = &Help;
				break;


		}
	}
	
	if (sp_titlebar.u < selection*64)
		sp_titlebar.u += ( selection*64 - sp_titlebar.u) / 4;	
	if (sp_titlebar.u > selection*64)
		sp_titlebar.u -= ( sp_titlebar.u - selection*64) / 4;

	DrawMenu();

}



int PlayerSelect(void){
	static int selection = 0, items = 1;	
	extern int level_1[LEVELDY][LEVELDX], level; 

	
	GetPadData(0, &Pad0);
	if((Pad0.Press & PadDown)	&& (selection<items))	{ selection++; }
	if((Pad0.Press & PadUp) 	&& (selection>0))		{ selection--; }

	if(Pad0.Press & PadCross){
		PlaySFX(&swish);
		do{
			sp_titlebar.x += ( (SCNW+16) - sp_titlebar.x) / 4;
			DrawMenu();
		}while(sp_titlebar.x <= SCNW);
		

		level = 1;
		initplayer(&aapj);	
		StartFrame();	
		EndFrame();	
		StartFrame();	
		EndFrame();	
		StartFrame();	
		drawText(200,220,"` loading `", 11);		
		GsSortSprite(&sp_title1, Gfx.pOT, 0);
		GsSortSprite(&sp_title2, Gfx.pOT, 0);
		EndFrame();		
		// ------------------------------------------------------------------------------------ load level from file
				loadlevel("levels/level1/");		
		// ---------------------------------------------------------------------------------------------------------

		switch(selection){
		case 0:					// -------------------------------------  load pj 	
			if(!ConfigureSprite(&sp_player, "gfx/aapj.tim", 10, 10))
				{ResetGraph(3);	return 0;}							
				sp_player.w 	= 16;
				sp_player.h 	= 32;
				whatPlayer 		= 0;
			DoState = &LevelStart;
			break;
		case 1:					// -------------------------------------  load yasmin 	
			if(!ConfigureSprite(&sp_player, "gfx/yasmin.tim", 10, 10))
				{ResetGraph(3);	return 0;}
				sp_player.w 	= 16;
				sp_player.h 	= 32;	
				whatPlayer 		= 1;					
			DoState = &LevelStart;
			break;	
		}
	}
	
	if(Pad0.Press & PadTriangle){
		do{
			sp_titlebar.x += ( (SCNW+16) - sp_titlebar.x) / 4;
			DrawMenu();
		}while(sp_titlebar.x <= SCNW);
		
		
		sp_titlebar.x 		= 0;
		sp_titlebar.y 		= SCNH;
		sp_titlebar.w 		= 64;
		sp_titlebar.h 		= 12;
		sp_titlebar.u 		= 0;
		sp_titlebar.v 		= 0;
		sp_titlebar.scalex 	= 4096 * 5;
		sp_titlebar.scaley 	= 4096 * 5;
		do{
			sp_titlebar.y -= (sp_titlebar.y-((SCNH/4)-8)) / 4;
			DrawMenu();
		}while(sp_titlebar.y >= (SCNH/4));
		DoState = &MainMenu;
		return 1;
	}	
	
	if (sp_titlebar.v < (12+selection*64))
		sp_titlebar.v += ( (12+selection*64) - sp_titlebar.v) / 4;	
	if (sp_titlebar.v > (12+selection*64))
		sp_titlebar.v -= ( sp_titlebar.v - (12+selection*64)) / 4;
	
	DrawMenu();
}















int OptionsMenu(void){
static int selection = 0, items = 1, vol;
extern GsSPRITE sp_titlebar;
extern GsSPRITE sp_title1;
extern GsSPRITE sp_title2;	
extern int sfxvol, musicvol;
	GetPadData(0, &Pad0);
	
	if((Pad0.Press & PadDown)	&& (selection<items))	{ selection++; }
	if((Pad0.Press & PadUp) 	&& (selection>0))		{ selection--; }
	if(Pad0.Press & PadTriangle){
		do{
			sp_titlebar.y += ( (SCNH+16) - sp_titlebar.y) / 4;			
			DrawOptionMenu(selection, vol);
		}while(sp_titlebar.y <= SCNH);
		
		sp_titlebar.x 		= 0;		sp_titlebar.y 		= SCNH;
		sp_titlebar.w 		= 64;		sp_titlebar.h 		= 12;
		sp_titlebar.u 		= 64;		sp_titlebar.v 		= 0;
		sp_titlebar.scalex 	= 4096 * 5;	sp_titlebar.scaley 	= 4096 * 5;
		
		do{
			sp_titlebar.y -= (sp_titlebar.y-((SCNH/4)-8)) / 4;
			DrawMenu();
		}while(sp_titlebar.y >= (SCNH/4));
		DoState = &MainMenu;
		return 1;
	}
		
	
	switch(selection){
		case 0:					// -------------------------------------  sfx 	
			if(Pad0.Press & PadRight)	{ sfxvol++; PlaySFX(&swish); }
			if(Pad0.Press & PadLeft)	{ sfxvol--; PlaySFX(&swish); }
			if (sfxvol > 10) sfxvol = 10;
			if (sfxvol < 0) sfxvol = 0;
			vol = sfxvol;
			break;
		case 1:					// -------------------------------------  music 
			if(Pad0.Press & PadRight)	{ musicvol++; PlaySFX(&swish); }
			if(Pad0.Press & PadLeft)	{ musicvol--; PlaySFX(&swish); }
			if (musicvol > 10) musicvol = 10;
			if (musicvol < 0) musicvol = 0;
			vol = musicvol;
			break;
	}
		
	DrawOptionMenu(selection, vol);


}























int Credits(void){
	GetPadData(0, &Pad0);
	if((Pad0.Press & PadCross)	|| (Pad0.Press & PadTriangle))
	{
		do{
			sp_titlebar.y = 0;
			sp_titlebar.x += (SCNW+52 - sp_titlebar.x) / 4;
			DrawMenu();
		}while(sp_titlebar.x <= SCNW);

	
		sp_titlebar.x 		= 0;
		sp_titlebar.y 		= SCNH;
		sp_titlebar.w 		= 64;
		sp_titlebar.h 		= 12;
		sp_titlebar.u 		= 128;
		sp_titlebar.v 		= 0;
		sp_titlebar.scalex 	= 4096 * 5;
		sp_titlebar.scaley 	= 4096 * 5;
		do{
			sp_titlebar.y -= (sp_titlebar.y-((SCNH/4)-8)) / 4;
			DrawMenu();
		}while(sp_titlebar.y >= (SCNH/4));
	
		DoState = &MainMenu;
	}
}



int Help(void){
	GetPadData(0, &Pad0);
	if((Pad0.Press & PadCross)	|| (Pad0.Press & PadTriangle))
	{
		do{
			sp_titlebar.u 		= 80;
			sp_titlebar.y += ( (SCNH+16) - sp_titlebar.y) / 4;
			DrawMenu();
		}while(sp_titlebar.y <= SCNH);
	
		sp_titlebar.x 		= 0;
		sp_titlebar.y 		= SCNH;
		sp_titlebar.w 		= 64;
		sp_titlebar.h 		= 12;
		sp_titlebar.u 		= 192;
		sp_titlebar.v 		= 0;
		sp_titlebar.scalex 	= 4096 * 5;
		sp_titlebar.scaley 	= 4096 * 5;
		do{
			sp_titlebar.y -= (sp_titlebar.y-((SCNH/4)-8)) / 4;
			DrawMenu();
		}while(sp_titlebar.y >= (SCNH/4));
	
		DoState = &MainMenu;
	}
}



int GetUserInput(){

	extern S_player aapj;	
	extern S_enemy badguy[NOENEMY+1];
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[10];
	static int jmp = 7, DBUG_movespeed = 2;
	int i;
	
	extern int level_1[LEVELDY][LEVELDX];
	
	
	GetPadData(0, &Pad0);
	GetPadData(1, &Pad1);

	if(Pad0.State & PadL1)
	if(Pad0.State & PadR1)
	
	if(Pad0.State & PadSelect)
			DoState = &MainMenu;
				
	if(Pad0.Press & PadStart){	//quit program
		DoState = &Paused;
	}	


	if(Pad0.State & PadR2)	{	
		for (i=0;i<NOENEMY;i++){
			badguy[i].actor.object.entity.x = badguy[i].actor.startpos.x;
			badguy[i].actor.object.entity.y = badguy[i].actor.startpos.y;
			badguy[i].actor.object.yvel 	= -1;
			badguy[i].actor.health			= 1;
			badguy[i].actor.object.entity.sprite->scalex = 4096;
		}
		
		for (i=0;i<10;i++)
			DiscoLoveFlower[i].collected = 0;
		for (i=0;i<199;i++)
			vinyl[i].collected = 0;
	}	
	
	if(Pad0.State & PadRight)	{ aapj.actor.object.xvel +=DBUG_movespeed; }
	if(Pad0.State & PadLeft)	{ aapj.actor.object.xvel -=DBUG_movespeed; }
	
	if(Pad0.Press & PadCross)	{ 
		if (aapj.actor.jumping == 0){
			if (aapj.actor.object.yvel > aapj.actor.maxjump)
				aapj.actor.object.yvel = aapj.actor.maxjump -DBUG_movespeed-1;
				aapj.actor.jumping = 1;
				PlaySFX(&playerjump);	
		}			
	}

		aapj.actor.object.xvel = 0;
		DBUG_movespeed = 2;
		
		if(Pad0.State & PadSquare)	{ DBUG_movespeed = 3; }
		if(Pad0.Release & PadSquare){ DBUG_movespeed = 2; }
						
		
		if(Pad0.State & PadRight)	{ 
			aapj.actor.object.xvel =DBUG_movespeed; 
			aapj.actor.object.entity.frame += DBUG_movespeed;
		}
		if(Pad0.State & PadLeft)	{ 
			aapj.actor.object.xvel =-DBUG_movespeed; 
			aapj.actor.object.entity.frame += DBUG_movespeed;
		}
		


		
		
	

	if(Pad0.State & PadL2){ 
	aapj.actor.object.entity.x = aapj.actor.startpos.x; 
	aapj.actor.object.entity.y = aapj.actor.startpos.y;
	aapj.actor.jumping = 0;
	aapj.actor.object.yvel = 0;		
	}



}



