#include "base.h"
#include "graphics.h"
#include "draw.h"
#include <stdio.h>
#include <strings.h>


void DrawSelectionBox(){
	extern GsSPRITE sp_player;
	extern drawlayer lyr_0_main;
	extern int x1, y1, x2, y2, select;
	extern int CopyBuffer[64][64];
	int startx, starty, endx, endy, tx, ty;

	startx = x1;	starty = y1;
	endx = x2;		endy = y2;

	if(x2 < x1){
		startx = x2;
		endx = x1;
	}
	if(y2 < y1){
		starty = y2;
		endy = y1;
	}
	
	//--------------------------------------------- draw copy icon
	sp_player.x = x2+lyr_0_main.layerx;
	sp_player.y = y2+lyr_0_main.layery;
	sp_player.u = 32;
	sp_player.v = 0;	
	sp_player.w = 8;
	sp_player.h = 8;	
	
	GsSortSprite(&sp_player, Gfx.pOT, 0);


	//--------------------------------------------- draw selection box
	sp_player.u = 16;
	sp_player.v = 0;
	sp_player.w = 16;
	sp_player.h = 16;	
	for(tx = startx; tx <= endx ;tx += 16){
		for(ty = starty; ty <= endy ;ty += 16){
			sp_player.x = tx+lyr_0_main.layerx;
			sp_player.y = ty+lyr_0_main.layery;
			GsSortSprite(&sp_player, Gfx.pOT, 0);
		}
	}
	
	sp_player.u = 0;
	sp_player.v = 0;
	sp_player.w = 16;
	sp_player.h = 16;
}

void DrawCopy(){
	extern S_player aapj;
	extern GsSPRITE sp_copyover;
	extern drawlayer lyr_0_main;
	extern int x1, y1, x2, y2, select;
	extern int CopyBuffer[64][64];
	extern tile tilelist[144];
	int atx, aty, tx, ty;
	
	atx = (aapj.actor.object.entity.x)/16;
	aty = (aapj.actor.object.entity.y)/16;	
	
	for(tx = atx; tx < 64 ;tx ++){
		for(ty = aty; ty < 64 ;ty ++){
			//if(CopyBuffer[ty][tx] > 0){
				sp_copyover.x = (tx<<4)+lyr_0_main.layerx;
				sp_copyover.y = ty+lyr_0_main.layery;			
				sp_copyover.u = 32;
				sp_copyover.v = 32;
			//	sp_copyover.u = tilelist[CopyBuffer[ty][tx]].u;
			//	sp_copyover.v = tilelist[CopyBuffer[ty][tx]].v;
				GsSortSprite(&sp_copyover, Gfx.pOT, 0);	
			//}
		}
	}
}

int DrawFrame(){
	extern S_player aapj;
	extern S_enemy badguy[NOENEMY+1];
	extern GsSPRITE sp_BG_0;
	extern GsSPRITE sp_collectable;
	extern GsSPRITE sp_font;
	extern drawlayer lyr_bg0;
	extern drawlayer lyr_0_main;
	
	extern int bg01[LEVELDY/4][LEVELDX/4];
	extern tile bg01tilelist[16];
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[200];
	extern S_collectable otherCollect[32];
	extern int dooverlay, select;
	int i, facing;
	extern char displaystring[256];


	StartFrame();		
		
		
		//draw any messages ------------------------------------------
		sp_font.r = 128;	sp_font.g = 128;	sp_font.b = 128;	
		drawText(64,32,displaystring, 24);		
	
		//DrawCopy();
		if(dooverlay == 1) DrawOverlay();
		if(select ==1) DrawSelectionBox();
		
		drawentity(&aapj.actor.object.entity, 0);							//drawplayer		

		for (i=0;i<NOENEMY;i++){

			badguy[i].actor.object.entity.sprite->v = badguy[i].type *16;
			if(badguy[i].actor.health == 0){
				badguy[i].actor.object.entity.sprite->scaley = 1024;	//set scale squashed
				if( (badguy[i].actor.object.entity.x > (aapj.actor.object.entity.x-240)) && (badguy[i].actor.object.entity.x < (aapj.actor.object.entity.x+240)) )
					drawentity(&badguy[i].actor.object.entity, facing);				//draw badguys				
				}				
			else{
				if (badguy[i].actor.object.xvel < 0)
					facing = 1;
				else
					facing = 0;
				badguy[i].actor.object.entity.sprite->scaley = 4096;	//set scale normal	
				if( (badguy[i].actor.object.entity.x > (aapj.actor.object.entity.x-240)) && (badguy[i].actor.object.entity.x < (aapj.actor.object.entity.x+240)) )
					drawentity(&badguy[i].actor.object.entity, facing);		//draw badguys
			}
		}
			
		//#########################################################################################################
		//#########################################################################################################
		// AAAAAAAAAAAAAAAAAAAARRRRRRRRRGGGGGGGGGGHHHHHHHHHHHHHH
		// for whatever reason this doesnt work properly if you use drawentity()
		for( i = 0; i<199; i++){	
		
			if(vinyl[i].collected == 0){
				if( (vinyl[i].entity.x > (aapj.actor.object.entity.x-240)) && (vinyl[i].entity.x < (aapj.actor.object.entity.x+240)) ){

				vinyl[i].entity.frame+=1;		
				sp_collectable.x = vinyl[i].entity.x+lyr_0_main.layerx;
				sp_collectable.y = vinyl[i].entity.y+lyr_0_main.layery;
				sp_collectable.u = ((vinyl[i].entity.frame>>3)%4)*16;;
				sp_collectable.v = 0;
		
				GsSortSprite(&sp_collectable, Gfx.pOT, 0);
				}
			}
		}
	
		for( i = 0; i<10; i++){
			
			if(DiscoLoveFlower[i].collected == 0){
				DiscoLoveFlower[i].entity.frame+=2;
				if( (DiscoLoveFlower[i].entity.x > (aapj.actor.object.entity.x-240)) && (DiscoLoveFlower[i].entity.x < (aapj.actor.object.entity.x+240)) ){

			
				sp_collectable.x = DiscoLoveFlower[i].entity.x+lyr_0_main.layerx;
				sp_collectable.y = DiscoLoveFlower[i].entity.y+lyr_0_main.layery;
				sp_collectable.u = ((DiscoLoveFlower[i].entity.frame>>3)%4)*16;
				sp_collectable.v = 16;
				GsSortSprite(&sp_collectable, Gfx.pOT, 0);
				}
			}
		}
			
		for( i = 0; i<32; i++){
			
			if(otherCollect[i].collected == 0){
				if( (otherCollect[i].entity.x > (aapj.actor.object.entity.x-240)) && (otherCollect[i].entity.x < (aapj.actor.object.entity.x+240)) ){

				otherCollect[i].entity.frame++;
			
				sp_collectable.x = otherCollect[i].entity.x+lyr_0_main.layerx;
				sp_collectable.y = otherCollect[i].entity.y+lyr_0_main.layery;
				sp_collectable.u = ((otherCollect[i].entity.frame>>3)%4)*16;;
				sp_collectable.v = otherCollect[i].type *16;
				GsSortSprite(&sp_collectable, Gfx.pOT, 0);
				}
			}
		}
		

		//#########################################################################################################
		//#########################################################################################################

		
		
		
		
		drawmain();														//draw level
		//DrawBGLayer(&sp_BG_0, &lyr_bg0, bg01tilelist);					//draw background
		
	EndFrame();
	return 0;
}

// =======================================================================================
// draw main level (layer 0 ==============================================================

void drawmain(void){
	int tx,ty;
	int startx, endx, starty, endy;
	extern GsSPRITE sp_level;
	extern drawlayer lyr_0_main;
	extern int level_1[LEVELDY][LEVELDX];
	extern tile tilelist[144];
	
	//DrawOverlay();

	startx = -(lyr_0_main.layerx / TILESCALE);
	endx = startx +21;
	starty = -(lyr_0_main.layery / TILESCALE);
	endy = starty +16;
	colourlayer(&lyr_0_main, 5);
	for(tx=startx;tx<endx;tx++){			
		for(ty=starty;ty<endy;ty++){
			if(level_1[ty][tx] != 0){
				sp_level.x = (tx<<4)+lyr_0_main.layerx;
				sp_level.y = (ty<<4)+lyr_0_main.layery;		
				sp_level.r = lyr_0_main.dr;		
				sp_level.g = lyr_0_main.dg;		
				sp_level.b = lyr_0_main.db;
				sp_level.u = tilelist[level_1[ty][tx]].u;
				sp_level.v = tilelist[level_1[ty][tx]].v;
				GsSortSprite(&sp_level, Gfx.pOT, 0);	
			}	
		}	
	}
}
// =======================================================================================
// change overall colour mod =============================================================

void colourlayer(drawlayer *layer, int speed){
	if (speed == 0 ){
		layer->dr = layer->r;
		layer->dg = layer->g;
		layer->db = layer->b;
	}
	else{
					if (layer->dr < layer->r) layer->dr += speed;
			else 	if (layer->dr > layer->r) layer->dr -= speed;
	
					if (layer->dg < layer->g) layer->dg += speed;
			else 	if (layer->dg > layer->g) layer->dg -= speed;
			
					if (layer->db < layer->b) layer->db += speed;
			else 	if (layer->db < layer->b) layer->db -= speed;
	}
}
// =======================================================================================
// draw an entity =========================================================================

void drawentity(S_entity *todraw, int dir){		//0=l to r, 1 = r to l
	extern drawlayer lyr_0_main;
	int fr;
	if (dir){
		todraw->sprite->scalex = -ONE;
	}
	else
		todraw->sprite->scalex = ONE;

	fr = ((todraw->frame>>3)%4);
	todraw->sprite->u = fr*16;
	
	todraw->sprite->x = todraw->x+lyr_0_main.layerx + todraw->sprite->mx;
	todraw->sprite->y = todraw->y+lyr_0_main.layery + todraw->sprite->my;

	GsSortSprite(todraw->sprite, Gfx.pOT, 0);
}


// =======================================================================================
// show how much has been loaded =========================================================

void loadprogress(int stage){
	int i;

	StartFrame(); 
		FntPrint(Gfx.FntID, "\n\n\n\n\n\n\tloading [");
		
	for(i=0;i<stage;i++){
		FntPrint(Gfx.FntID, "~c999:");

	}	
	for(i=0;i<(LOADSTAGES-stage);i++){
		FntPrint(Gfx.FntID, " ");

	}
	FntPrint(Gfx.FntID, "~c999]");
	EndFrame();

}

void DrawOverlay(void){
	extern GsSPRITE sp_level;
	extern GsSPRITE sp_player;
	extern S_player aapj;
	extern int level_1[LEVELDY][LEVELDX];	
	extern tile tilelist[144];

	sp_player.x =  tilelist[level_1[(aapj.actor.object.entity.y)/16][(aapj.actor.object.entity.x)/16]].u + SCNW-208;;	
	sp_player.y =  tilelist[level_1[(aapj.actor.object.entity.y)/16][(aapj.actor.object.entity.x)/16]].v + 16;	
	
	GsSortSprite(&sp_player, Gfx.pOT, 0);

	sp_level.w 		= 192;
	sp_level.h 		= 192;
	sp_level.x 		= SCNW-208;
	sp_level.y 		= 16;
	sp_level.u 		= 0;
	sp_level.v 		= 0;

	GsSortSprite(&sp_level, Gfx.pOT, 0);

	sp_level.w 		= 16;
	sp_level.h 		= 16;


}
/*

void DrawBGLayer(GsSPRITE *MySprite, drawlayer *MyLayer, tile MyTilelist[]){
	int tx,ty;
	int startx, endx, starty, endy;
	extern drawlayer lyr_0_main;
	
	extern int bg01[LEVELDY/4][LEVELDX/4];
	
	MyLayer->layerx = lyr_0_main.layerx/2;
	MyLayer->layery = lyr_0_main.layery/2;

	startx = -(MyLayer->layerx / (TILESCALE*2));
	endx = startx +11;
	starty = -(MyLayer->layery / (TILESCALE*2));
	endy = starty +8;
	
	//colourlayer(&lyr_bg0, 5);
	for(tx=startx;tx<endx;tx++){			
		for(ty=starty;ty<endy;ty++){
			//if(bg01[ty][tx] != 0){
				MySprite->x = (tx<<5)+MyLayer->layerx;
				MySprite->y = (ty<<5)+MyLayer->layery;		
				//MySprite->r = lyr_bg0.dr;		
				//MySprite->g = lyr_bg0.dg;		
				//MySprite->b = lyr_bg0.db;
				MySprite->u = MyTilelist[bg01[ty][tx]].u;
				MySprite->v = MyTilelist[bg01[ty][tx]].v;
				GsSortSprite(MySprite, Gfx.pOT, 0);	
			//}	
		}	
	}
}
*/

void drawText(int x, int y, char *string, int linelength){
int i, line = 0, length;
char num;
char tc = 'k';
extern GsSPRITE sp_font;
length = strlen(string);

	for (i = 0; i<length; i++){
		num = string[i]-32;
		sp_font.x = x+(i%linelength)*8;
		sp_font.y = y+(i/linelength)*8;
		sp_font.u = (num%8)*8;
		sp_font.v = (num/8)*8;
		GsSortSprite(&sp_font, Gfx.pOT, 0);	
	}

}















