#include "base.h"
#include "init.h"
#include <stdio.h>
#include <__rts_info_t__.h>

//tile tilelist[64];
//drawlayer lyr_0_main;


GsSPRITE sp_level;
GsSPRITE sp_player;
GsSPRITE sp_enemy;
GsSPRITE sp_collectable;
GsSPRITE sp_copyover;
GsSPRITE sp_overlay;
GsSPRITE sp_BG_0;
GsSPRITE sp_font;

int editmode = 0, selection = 0;

int dooverlay = -1;
int x1, y1, x2, y2, select = -1;

S_collectable DiscoLoveFlower[10];
S_collectable otherCollect[32];
S_collectable vinyl[200];

drawlayer lyr_0_main;
drawlayer lyr_bg0;
drawlayer lyr_sun;
tile tilelist[144];

int bg01[LEVELDY/4][LEVELDX/4];
tile bg01tilelist[16];

int CopyBuffer[64][64] = {-1};

char displaystring[256];

int (* DoState)(void);

S_player aapj;
S_enemy badguy[NOENEMY+1];
int collisionmap[15][TILESCALE] = {
//flat= 

{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},				//flat ground		1
{15,15,14,14,13,13,12,12,11,11,10,10,9,9,8,8},	//slope30lower 	l	2
{7,7,6,6,5,5,4,4,3,3,2,2,1,1,0,0},				//slope30upper 	l	3
{8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,15},	//slope30lower 	r	4
{0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7},				//slope30upper 	r	5

{15,14,13,12,11,10,9,8,7,6,5,4,3,2,1},	//slope45		l			6
{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},	//slope45		r			7

{0,0,1,1,1,1,1,2,2,2,2,3,3,3,4,4},	//uneven ground					8
{4,4,4,4,4,4,4,5,5,5,5,5,5,5,4,4},	//uneven ground					9
{4,4,4,4,3,3,3,3,3,3,3,4,4,4,4,4},	//uneven ground					10
{4,4,4,4,3,3,3,3,2,2,2,2,1,1,1,1},	//uneven ground					11
{0,0,1,1,2,2,2,2,2,2,2,2,1,1,0,0},	//uneven ground					12
{0,0,0,0,1,1,2,2,3,3,4,4,4,4,4,4},	//uneven ground					13
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},	//uneven ground					14

};


void InitialiseHeap(void)
{
	// heap starts after the main program on a 16-byte boundary
	unsigned long	lclHeapStart=(_end & 0xFFFFFFF0L)+0x10;

	// heap extends to the bottom of the stack.
	unsigned long lclHeapSize=((_stack_addr-(_stack_size<<10)) & 0xFFFFFFF0L)-lclHeapStart;

	InitHeap((unsigned long *)lclHeapStart, lclHeapSize);

}

int level_1[LEVELDY][LEVELDX];


void buildmaplookup(void){
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[200];
	
int index = 0;
		while(index<143){
			tilelist[index].u = (index%12)*16;
			tilelist[index].v = (index/12)*16;
			tilelist[index].rotate = 0;	
			tilelist[index].friction = 1;	
			tilelist[index].collide = 0;

			if (index<15){
				bg01tilelist[index].u =  (index%4)*32;
				bg01tilelist[index].v =  (index/4)*32;
			}
			index++;
		};

		tilelist[2].collide = 
		tilelist[8].collide = 
		tilelist[9].collide = 		
		tilelist[10].collide =  
		tilelist[36].collide = 
		tilelist[37].collide = 
		tilelist[38].collide = 
		tilelist[39].collide = 
		tilelist[40].collide = 
		tilelist[41].collide = 
		tilelist[42].collide = 
		tilelist[43].collide = 
		tilelist[44].collide = 
		tilelist[45].collide = 
		tilelist[46].collide = 
		tilelist[47].collide = 
		tilelist[60].collide = 
		tilelist[61].collide = 
		tilelist[62].collide = 
		tilelist[63].collide = 
		tilelist[70].collide =
		tilelist[71].collide = 1;	//flat ground
		
		
		tilelist[82].collide =
		tilelist[83].collide =
		tilelist[94].collide =
		tilelist[95].collide = 99;	//walls
		
 
		tilelist[12].collide = 5;	//30degree
		tilelist[13].collide = 4;
		tilelist[14].collide = 2;
		tilelist[15].collide = 3;		
		
		tilelist[24].collide = 5;
		tilelist[25].collide = 4;
		tilelist[26].collide = 2;
		tilelist[27].collide = 3;
		
		tilelist[48].collide = 7;	//45degree
		tilelist[49].collide = 6;
		
		tilelist[50].collide = 7;
		tilelist[51].collide = 6;		
		
		tilelist[16].collide = 8;	//squiggly ground
		tilelist[17].collide = 9;
		tilelist[18].collide = 10;
		tilelist[19].collide = 11;
		tilelist[20].collide = 12;
		tilelist[21].collide = 13;
		tilelist[22].collide = 14;
		
		tilelist[28].collide = 8;
		tilelist[29].collide = 9;
		tilelist[30].collide = 10;
		tilelist[31].collide = 11;
		tilelist[32].collide = 12;
		tilelist[33].collide = 13;
		tilelist[34].collide = 14;
		
		
	for ( index = 0; index<10; index++){
	
		DiscoLoveFlower[index].entity.x = -16;
		DiscoLoveFlower[index].entity.y = -16;		
		DiscoLoveFlower[index].entity.frame = 0;		
		DiscoLoveFlower[index].entity.anim  = 0;
		
		DiscoLoveFlower[index].type = 1;		
		DiscoLoveFlower[index].score = 1000;	
		DiscoLoveFlower[index].collected = 0;	
		
		
		DiscoLoveFlower[index].entity.sprite->w = 16;
		DiscoLoveFlower[index].entity.sprite->h = 16;
		
	}	
	
	for ( index = 0; index<200; index++){
	
		vinyl[index].entity.x = -16;
		vinyl[index].entity.y = -16;		
		vinyl[index].entity.frame = 0;		
		vinyl[index].entity.anim  = 0;
		
		vinyl[index].type = 0;		
		vinyl[index].score = 100;	
		vinyl[index].collected = 0;	
		
		
		vinyl[index].entity.sprite->w = 16;
		vinyl[index].entity.sprite->h = 16;
		
	}
	
	for ( index = 0; index<32; index++){
	
		otherCollect[index].entity.x = -16;
		otherCollect[index].entity.y = -16;		
		otherCollect[index].entity.frame = 0;		
		otherCollect[index].entity.anim  = 0;
		
		otherCollect[index].type = 0;		
		otherCollect[index].score = 0;	
		otherCollect[index].collected = 0;	
		
		
		otherCollect[index].entity.sprite->w = 16;
		otherCollect[index].entity.sprite->h = 16;
		
	}
	

	strcpy(displaystring, "");

}

void InitLayers(void){
int x,y;

	lyr_0_main.layerx 	= 0;
	lyr_0_main.layery 	= 0;	
	lyr_0_main.r 		= 128;	
	lyr_0_main.g 		= 128;
	lyr_0_main.b 		= 128;
	lyr_0_main.dr 		= 128;
	lyr_0_main.dg 		= 128;
	lyr_0_main.db		= 128;	
	
	lyr_bg0.layerx= 0;
	lyr_bg0.layery= 0;	
	lyr_bg0.r 		= 128;	
	lyr_bg0.g 		= 128;
	lyr_bg0.b 		= 128;
	lyr_bg0.dr 		= 128;
	lyr_bg0.dg 		= 128;
	lyr_bg0.db		= 128;
	
	lyr_sun.layerx 	= 0;
	lyr_sun.layery 	= 0;	
	lyr_sun.r 		= 128;	
	lyr_sun.g 		= 128;
	lyr_sun.b 		= 128;
	lyr_sun.dr 		= 128;
	lyr_sun.dg 		= 128;
	lyr_sun.db		= 128;
	
	
	
	for (y=0; y< LEVELDY/4; y++){
		for (x=0; x< LEVELDX/4; x++){
			bg01[y][x] = rand()%16;
		}
		bg01[y][0] = 3;
	}
}

void ResetPlayer(S_player *theplayer){
int i;
	theplayer->actor.object.entity.x	= 64;
	theplayer->actor.object.entity.y	= 64;
	theplayer->actor.object.entity.frame= 0;
	theplayer->actor.object.entity.anim	= 0;

	
	theplayer->actor.object.hillx		= 8;
	theplayer->actor.object.hilly		= 31;	
	theplayer->actor.object.xvel		= 0;
	theplayer->actor.object.yvel		= 0;	
	theplayer->actor.object.maxspeed	= 3;	
	
	theplayer->actor.maxjump			= -8;
	theplayer->actor.jumping			= 0;
		
	theplayer->actor.w					= 16;
	theplayer->actor.h					= 32;
	theplayer->actor.health 			= 1;

	for (i = 0; i <9; i++){		
		theplayer->oldpos[i].x 			= theplayer->actor.object.entity.x;
		theplayer->oldpos[i].y 			= theplayer->actor.object.entity.y;
	}
	
	theplayer->old_at					= 0;
	theplayer->actor.lastpos.x 			= 0;
	theplayer->actor.lastpos.y 			= 0;

	theplayer->actor.oldcollision		= 0;
	theplayer->actor.newcollision		= 0;


}

void initplayer(S_player *theplayer){
	
	ResetPlayer(theplayer);
	theplayer->actor.object.entity.sprite = &sp_player;

	
	theplayer->score 					= 0;
	theplayer->discolove				= 0;
	theplayer->showmydiscolove			= 0;	
	theplayer->records 					= 3;	
	theplayer->lives 					= 3;	
}



void initenemy(S_enemy *badguy, int x, int y, int type){

	badguy->actor.object.entity.sprite = &sp_enemy;
	badguy->actor.object.entity.sprite->scaley = 4096;
	
	badguy->actor.object.entity.x		= -16;
	badguy->actor.object.entity.y		= -16;
	badguy->actor.object.entity.frame	= 0;
	badguy->actor.object.entity.anim	= 0;

	
	badguy->actor.object.hillx			= 8;
	badguy->actor.object.hilly			= 15;	
	badguy->actor.object.xvel			= 0;
	
	badguy->actor.object.yvel			= 0;	
	badguy->actor.object.maxspeed		= 3;
		
	badguy->actor.w						= 16;
	badguy->actor.h						= 16;
	badguy->actor.health 				= 0;
	badguy->actor.maxjump				= 0;
	badguy->actor.jumping				= 0;	
	
	
	badguy->type 						= 0;
	badguy->aware 						= 1;
	badguy->aggressive 					= 0;
	badguy->provoked 					= 0;
	badguy->score 						= 100;



}