/*******************************************/
/* Reading the control pad buffers - pad.c */
/*******************************************/

#include <libps.h>
#include "defines.h" 
#include "structures.h" 
#include "globals.h"  
#include "pad.h"

volatile u_char *bb[2];

void InitPads(void) 
	{
	GetPadBuf(&bb[0],&bb[1]);
	}
	
int PadConnected(int port) 
	{ 
	return *bb[port]; 
	}
	
int PadType(int port) 
	{ 
	return (*(bb[port]+1))>>4; 
	}
	
int PadState(int port) 
	{ 
	return ~(*(bb[port]+3) | *(bb[port]+2)<<8); 
	}
	
int PadLHorz(int port) 
	{ 
	return *(bb[port]+6); 
	}
	
int PadLVert(int port) 
	{ 
	return *(bb[port]+7); 
	}
	
int PadRHorz(int port) 
	{ 
	return *(bb[port]+4); 
	}
	
int PadRVert(int port) 
	{
	return *(bb[port]+5); 
	}
	
int GetPadData(int Port, PadInfo *pPD)
	{
	pPD->Old = pPD->State;
	pPD->State = ~(*(bb[Port]+3) | *(bb[Port]+2)<<8);
	pPD->Toggle = pPD->Old ^ pPD->State;
	pPD->Press = pPD->Toggle & pPD->State;
	pPD->Release =  pPD->Toggle & pPD->Old;
	return(pPD->State);
}

void ClearPadData(int port, PadInfo *pPD)	//in pad.c
	{
	pPD->Old = 0;
	pPD->State = 0;
	pPD->Toggle = 0;
	pPD->Press = 0;
	pPD->Release =  0;
}
