//=============================================================================================================
// Action Afro Pj 
//-------------------------------------------------------------------------------------------------------------
//
// main file for AAPJ playstation tile based game, includes main() and game loop.
//
//=============================================================================================================

#define GLOBAL_OWNERSHIP
	 
#include "base.h" 
#include "graphics.h"
#include "pad.h"
#include "init.h"
#include "draw.h"
#include <stdlib.h>
#include "MWDebugIO.h"


//extern int (* DoState)(void);

int MainGame(void);
int MainMenu(void);
int Paused(void);
int PlayerSelect(void);
int Credits(void);
int Help(void);

int GetUserInput();



void main(){
extern S_player aapj;
extern S_enemy badguy[NOENEMY+1];
int i;

InitialiseHeap();
InitGfx();
InitPads();
InitLayers();
buildmaplookup();
initplayer(&aapj);

for (i=0;i<NOENEMY;i++)
	initenemy(&badguy[i],i*2+64,128,1);

Gfx.FntID = LoadFont();
	StartFrame();
	EndFrame();
	loadprogress(0);
	if(!ConfigureSprite(&sp_level, "gfx/level.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(1);
	if(!ConfigureSprite(&sp_collectable, "gfx/collect.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(2);
	if(!ConfigureSprite(&sp_player, "gfx/cursor.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(3);	
	if(!ConfigureSprite(&sp_enemy, "gfx/enemy.tim", 10, 10))
	{ResetGraph(3);	return;}
	loadprogress(4);



	sp_level.x 		= 0;
	sp_level.y 		= 0;
	sp_level.w 		= 16;
	sp_level.h 		= 16;
	
	sp_copyover.x 		= 0;
	sp_copyover.y 		= 0;
	sp_copyover.w 		= 16;
	sp_copyover.h 		= 16;	
	
	sp_player.x 	= 16;
	sp_player.y 	= 16;
	sp_player.w 	= 16;
	sp_player.h 	= 16;	
	

	sp_enemy.x 		= 0;
	sp_enemy.y 		= 0;
	sp_enemy.w 		= 16;
	sp_enemy.h 		= 16;
	sp_enemy.mx 	= sp_enemy.w/2;
	sp_enemy.my 	= 0;
	sp_enemy.scalex = 4096;
	sp_enemy.scaley = 4096;

	sp_collectable.w 		= 16;
	sp_collectable.h 		= 16;
	sp_collectable.x 		= 0;
	sp_collectable.y 		= 0;
	sp_collectable.u 		= 0;
	sp_collectable.v 		= 0;



	DoState = &MainGame;
	do{
		DoState();
	}while(1);
	
	return;
}



int MainGame(void){
		GetUserInput();
		GameLogic();
		DrawFrame();
}


int GetUserInput(){
	// externs ------------------------------------------------------------
	extern S_player aapj;	
	extern S_enemy badguy[NOENEMY+1];
	extern S_collectable DiscoLoveFlower[10];
	extern S_collectable vinyl[200];
	extern S_collectable otherCollect[32];	
	extern int CopyBuffer[64][64];
	extern int level_1[LEVELDY][LEVELDX];
	extern int editmode, selection;
	extern int dooverlay;
	extern int x1, y1, x2, y2, select;

	// local variables -----------------------------------------------------	
	unsigned char levelrw[LEVELDY+10][LEVELDX];	
	unsigned long fd;
	char *filename = "out.lvl";
	int result;
	void *outbuffer;
	int tx,ty, onx, ony;
	int movespeed =16;


	
	// calculations ========================================================
	GetPadData(0, &Pad0);
	GetPadData(1, &Pad1);
	
	//Write level to file "out.lvl"
	if(Pad1.State & PadDown){
		StartFrame();	
		FntPrint(Gfx.FntID,"~c000\n\n\n\t\writing files");	
		EndFrame();

		for(tx=0;tx<LEVELDX;tx++){// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- save layout to file						
			for(ty=0;ty<LEVELDY;ty++){				
				levelrw[ty][tx] = level_1[ty][tx];	//convert ints to chars
			}	
		}
		filename = "level/layout.lvl";
		fd = MWopen(filename, 0);												
		outbuffer = &levelrw[0][0];
		MWwrite(fd, outbuffer, (sizeof(unsigned char)*LEVELDY*LEVELDX));			
		MWclose(fd);
		

		for(tx=0;tx<398;tx+=2){	// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- save Vinyl to file
			levelrw[0][tx] 		= vinyl[tx/2].entity.x/16;
			levelrw[0][tx+1] 	= vinyl[tx/2].entity.y/16;
		}

		filename = "level/vinyl.pos";	
		fd = MWopen(filename, 0);												
		outbuffer = &levelrw[0][0];
		MWwrite(fd, outbuffer, (sizeof(S_collectable)*199));			
		MWclose(fd);
		
		
		for(tx=0;tx<20;tx+=2){	// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- save flowers to file
			levelrw[0][tx] 		= DiscoLoveFlower[tx/2].entity.x/16;
			levelrw[0][tx+1] 	= DiscoLoveFlower[tx/2].entity.y/16;
		}

		filename = "level/discolove.pos";	
		fd = MWopen(filename, 0);												
		outbuffer = &levelrw[0][0];
		MWwrite(fd, outbuffer, (sizeof(S_collectable)*10));			
		MWclose(fd);

		for(tx=0;tx<128;tx+=4){	// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- save collects to file
			levelrw[0][tx] 		= otherCollect[tx/4].entity.x/16;
			levelrw[0][tx+1] 	= otherCollect[tx/4].entity.y/16;
			levelrw[0][tx+2] 	= otherCollect[tx/4].type;
			levelrw[0][tx+3] 	= otherCollect[tx/4].score;
		}

		filename = "level/collect.pos";	
		fd = MWopen(filename, 0);												
		outbuffer = &levelrw[0][0];
		MWwrite(fd, outbuffer, (sizeof(S_collectable)*32));			
		MWclose(fd);

		for(tx=0;tx<128;tx+=4){	// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- save enemies to file
			levelrw[0][tx] 		= badguy[tx/4].actor.startpos.x/16;
			levelrw[0][tx+1] 	= badguy[tx/4].actor.startpos.y/16;
			levelrw[0][tx+2] 	= badguy[tx/4].type;
			levelrw[0][tx+3] 	= badguy[tx/4].actor.object.yvel;
		}
		
		filename = "level/enemy.pos";	
		fd = MWopen(filename, 0);												
		outbuffer = &levelrw[0][0];
		MWwrite(fd, outbuffer, (sizeof(S_collectable)*32));			
		MWclose(fd);
	}


	//Read level from file
	if(Pad1.State & PadUp){
		StartFrame();		
		FntPrint(Gfx.FntID,"~c000\n\n\n\treading files");	
		EndFrame();

		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get layout from file
		result = MWbload("level/layout.lvl", levelrw);					
		for(tx=0;tx<LEVELDX;tx++){	
			for(ty=0;ty<LEVELDY;ty++){				
				level_1[ty][tx] = levelrw[ty][tx];		
			}	
		}		
		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get vinyl from file
		result = MWbload("level/vinyl.pos", levelrw);
		for(tx=0;tx<398;tx+=2){
			vinyl[tx/2].entity.x = levelrw[0][tx]*16;
			vinyl[tx/2].entity.y = levelrw[0][tx+1]*16;
			vinyl[tx/2].collected = 0;
		}
		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get flowers from file
		result = MWbload("level/discolove.pos", levelrw);
		for(tx=0;tx<20;tx+=2){
			DiscoLoveFlower[tx/2].entity.x = levelrw[0][tx]*16;
			DiscoLoveFlower[tx/2].entity.y = levelrw[0][tx+1]*16;
			DiscoLoveFlower[tx/2].collected = 0;
		}
		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get collects from file
		result = MWbload("level/collect.pos", levelrw);
		for(tx=0;tx<128;tx+=4){
			otherCollect[tx/4].entity.x 	= levelrw[0][tx]*16;
			otherCollect[tx/4].entity.y 	= levelrw[0][tx+1]*16;
			otherCollect[tx/4].type 		= levelrw[0][tx+2];
			otherCollect[tx/4].score 		= levelrw[0][tx+3];
			otherCollect[tx/4].collected = 0;
		}
		// +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- get enemies from file
		result = MWbload("level/enemy.pos", levelrw);
		for(tx=0;tx<128;tx+=4){
			badguy[tx/4].actor.startpos.x 		= badguy[tx/5].actor.object.entity.x = levelrw[0][tx]*16 ;
			badguy[tx/4].actor.startpos.y 		= badguy[tx/5].actor.object.entity.y = levelrw[0][tx+1]*16;
			badguy[tx/4].type 					= levelrw[0][tx+2];
			badguy[tx/4].actor.object.yvel 		= (int)levelrw[0][tx+3];
		}
	}
	
	
	if(Pad0.Press & PadSelect){
		editmode ++;
		if (editmode > 4) editmode = 0;
		
		//0 = tile
		//1 = vinyl
		//2 = disco love
		//3 = collect
		//4 = enemy
	
	}
	
	switch(editmode){	//show what mode we're in
		case 0:
			FntPrint(Gfx.FntID,"~c111:  layout :");
			break;
		case 1:
			FntPrint(Gfx.FntID,"~c111:   vinyl :");
			break;
		case 2:
			FntPrint(Gfx.FntID,"~c111:  flower :");
			break;
		case 3:
			FntPrint(Gfx.FntID,"~c111: collect :");
			break;
		case 4:
			FntPrint(Gfx.FntID,"~c111:   enemy :");
			break;		
	}
	FntPrint(Gfx.FntID,"~c111 %d :", selection);


	x2 = aapj.actor.object.entity.x;
	y2 = aapj.actor.object.entity.y;

	if(Pad0.Press & PadL2)	{	//select		
		x1 = aapj.actor.object.entity.x;
		y1 = aapj.actor.object.entity.y;
		select = 1;
	}	
	if(Pad0.Release & PadL2)	{//select	
		select = 0;
	}

	//should overlay be shown?
	dooverlay = 0;
	if(Pad0.State & PadL1){
		if(editmode == 0)	dooverlay = 1;
	}
	if(Pad0.Press & PadL1){
		if(editmode != 0){
			selection-=1;
			if (selection < 0)	selection = 0;			
		}
	}

	//tile information:
	onx = (aapj.actor.object.entity.x)/16;
	ony = (aapj.actor.object.entity.y)/16;
	
	switch(editmode){	//show info for the mode we're in
		case 0:
			FntPrint(Gfx.FntID,"\n~c111(%d, %d) : %d :", onx, ony, level_1[ony][onx]);
			break;
		case 1:
			FntPrint(Gfx.FntID,"\n~c111(%d, %d)",vinyl[selection].entity.x,vinyl[selection].entity.y);
			break;
		case 2:
			FntPrint(Gfx.FntID,"\n~c111(%d, %d)",DiscoLoveFlower[selection].entity.x,DiscoLoveFlower[selection].entity.y);
			break;
		case 3:
			FntPrint(Gfx.FntID,"\n~c111(%d, %d) : %d : %dpts",otherCollect[selection].entity.x,otherCollect[selection].entity.y,  otherCollect[selection].type,  otherCollect[selection].score);
			break;
		case 4:
			FntPrint(Gfx.FntID,"\n~c111(%d, %d) : %d : dir %d",badguy[selection].actor.object.entity.x,badguy[selection].actor.object.entity.y, badguy[selection].type, badguy[selection].actor.object.yvel);
	}
	
	if(Pad0.Press & PadR1)	{	//copy		
		if (editmode == 0){
			if (select != 1) EditCopySingle(level_1[ony][onx]);
			if (select == 1) EditCopyBlock();
		}
		else
			selection++;		
	}	
	
	if(Pad0.Press & PadR2)	{	//paste	
		EditPaste();		
	}	

	
	if(Pad0.State & PadL1){
		if(Pad0.Press & PadRight)	{ level_1[ony][onx] ++;	}
		if(Pad0.Press & PadLeft)	{ level_1[ony][onx] --;	}	
		if(Pad0.Press & PadUp)		{ level_1[ony][onx] -=12;}
		if(Pad0.Press & PadDown)	{ level_1[ony][onx] +=12;}
		return 0;
	}

	//change current tile
	if(Pad0.State & PadCross){ 
		switch(editmode){
		case 0:
			if(Pad0.Press & PadRight)	{ level_1[ony][onx] ++;	}
			if(Pad0.Press & PadLeft)	{ level_1[ony][onx] --;	}	
			if(Pad0.Press & PadUp)		{ level_1[ony][onx] -=12;}
			if(Pad0.Press & PadDown)	{ level_1[ony][onx] +=12;}
			break;				
		case 1:	//vinyl
			vinyl[selection].entity.x = aapj.actor.object.entity.x;
			vinyl[selection].entity.y = aapj.actor.object.entity.y;		
			vinyl[selection].collected = 0;				
			selection;
			break;		
			break;
		case 2:	//disco love flowers
			DiscoLoveFlower[selection].entity.x = aapj.actor.object.entity.x;
			DiscoLoveFlower[selection].entity.y = aapj.actor.object.entity.y;		
			DiscoLoveFlower[selection].collected = 0;		
			selection;
			break;	
		case 3:	//other collects
			otherCollect[selection].entity.x = aapj.actor.object.entity.x;
			otherCollect[selection].entity.y = aapj.actor.object.entity.y;	
			otherCollect[selection].collected = 0;	
			if(Pad0.Press & PadRight)	{ otherCollect[selection].type ++;}
			if(Pad0.Press & PadLeft)	{ otherCollect[selection].type --;}	
			if(Pad0.Press & PadUp)		{ otherCollect[selection].score +=100;}
			if(Pad0.Press & PadDown)	{ otherCollect[selection].score -=100;}				
			break;	
		case 4:	//enemies
			badguy[selection].actor.object.entity.x = aapj.actor.object.entity.x;
			badguy[selection].actor.object.entity.y = aapj.actor.object.entity.y;	
			badguy[selection].actor.startpos.x = aapj.actor.object.entity.x;		
			badguy[selection].actor.startpos.y = aapj.actor.object.entity.y;				
			badguy[selection].type   = 1;			
			badguy[selection].actor.object.yvel = -1;			
			badguy[selection].actor.health = 1;	
			if(Pad0.Press & PadUp)		{ badguy[selection].type --;}
			if(Pad0.Press & PadDown)	{ badguy[selection].type ++;}		
			if(Pad0.Press & PadRight)	{ badguy[selection].actor.object.yvel =1;}
			if(Pad0.Press & PadLeft)	{ badguy[selection].actor.object.yvel =-1;}											   
			break;	
		}	
	return 0;	
	}
	



	if(Pad0.State & PadTriangle){ 
		switch(editmode){
			case 0:
				level_1[ony][onx]  = 0;
				break;
			case 1:
				vinyl[selection].entity.x = -16;
				vinyl[selection].entity.y = -16;		
				vinyl[selection].collected = 1;	
				break;		
			case 2:
				DiscoLoveFlower[selection].entity.x = -16;
				DiscoLoveFlower[selection].entity.y = -16;		
				DiscoLoveFlower[selection].collected = 1;	
				break;		
			case 3:
				otherCollect[selection].entity.x = -16;
				otherCollect[selection].entity.y = -16;		
				otherCollect[selection].collected = 1;	
				break;			
			return 0;
		}

	}

	//move in big steps
	if(Pad0.State & PadSquare){ 
		FntPrint(Gfx.FntID,"~c000\n8x step");
		if(Pad0.Press & PadRight)	{ aapj.actor.object.entity.x += movespeed*8;}
		if(Pad0.Press & PadLeft)	{ aapj.actor.object.entity.x += -movespeed*8;}
		if(Pad0.Press & PadUp)		{ aapj.actor.object.entity.y += -movespeed*8;}
		if(Pad0.Press & PadDown)	{ aapj.actor.object.entity.y += movespeed*8;}
		return 0;
	}


	//move in normal steps
	if(Pad0.Press & PadRight)	{ aapj.actor.object.entity.x += movespeed;}
	if(Pad0.Press & PadLeft)	{ aapj.actor.object.entity.x += -movespeed;}
	if(Pad0.Press & PadUp)		{ aapj.actor.object.entity.y += -movespeed;}
	if(Pad0.Press & PadDown)	{ aapj.actor.object.entity.y += movespeed;}


}



