/**********************
Henry S Fortuna
July 2001
***********************/

#include <libps.h>
#include "sprtconf.h"       

int ConfigureSprite(GsSPRITE * pSP, char * FileName, short xPosition, short yPosition)
	{
	GsIMAGE img, *pI;
	RECT rect, *pR;
	unsigned char buffer[BUFFERSIZE];
	unsigned long * SprAddress;
	int Ret;
	
	pR = &rect;
	pI = &img;
	
	printf("!Sprite Buffer Size = %d\n", BUFFERSIZE);

	Ret = MWbload(FileName, buffer);
	
	if(Ret <= 0)
	{
		printf("Error Loading %s\n", FileName);
		return 0;
	}
	
	if(Ret > BUFFERSIZE)
	{
		printf("Error Loading %s\nBuffer too Small\n", FileName);
		printf("Increse buffer size\n");
		return 0;
	
	}
	
	SprAddress = (unsigned long *)buffer;
	
	SprAddress++;
	GsGetTimInfo(SprAddress,&img);
	
	pR->x = pI->px;
	pR->y = pI->py;
	pR->w = pI->pw;
	pR->h = pI->ph;
	
    LoadImage(pR, pI->pixel);
    
    if ((pI->pmode >> 3)&0x01)
    	{
    	pR->x = pI->cx;
	    pR->y = pI->cy;
	    pR->w = pI->cw;
	    pR->h = pI->ch;
    	LoadImage(pR, pI->clut);
    	}
    	
    switch (pI->pmode) 
		{
		case 0x08:     //4 bit with CLUT
		  pSP->attribute = 0x00000000;
		  pSP->w = pI->pw*4;
		  pSP->tpage = GetTPage(0,0, pI->px, pI->py);
		  break;
		case 0x09:     //8 bit with CLUT
		  pSP->attribute = 0x01000000;
		  pSP->w = pI->pw*2;
		  pSP->tpage = GetTPage(1,0, pI->px, pI->py);
		  break;
		default:       //16 bit no CLUT - pmode = 0x02
		  pSP->attribute = 0x02000000;
		  pSP->w = pI->pw;
		  pSP->tpage = GetTPage(2,0, pI->px, pI->py);
		  break;
		  }
		  
	pSP->x = xPosition;
	pSP->y = yPosition;
	pSP->h = pI->ph;
	pSP->u = 0;
	pSP->v = 0;
	pSP->r = 128;
	pSP->g = 128;
	pSP->b = 128;
	pSP->cx = pI->cx;
	pSP->cy = pI->cy;
	pSP->mx = 0; //pSP->w/2;
	pSP->my = 0; //pSP->h/2;
	pSP->scalex = ONE;
	pSP->scaley = ONE;
	pSP->rotate = 0;
	
	
	return 1;
	}
  
