//**************Henry S Fortuna July-2001*********

#ifndef _STRUCTURES_H_
#define _STRUCTURES_H_


typedef struct
{
GsOT ot[2];
GsOT *pOT;							// Ordering tables to render double buffered graphics.
GsOT_TAG ottags[2][1<<OTLEN];		// The header info for the orering tables.
PACKET gpuPktArea[2][64*kBYTE];		// Memory for GPU packet data.
int buf;
int FntID;							// The current drawing (i.e. back) buffer for rendering.
}Graphics;

typedef struct		//in pad.h (or structures.h)
	{
	int Old;
	int State;
	int Toggle;
	int Release;
	int Press;
	}PadInfo;

typedef struct		
	{
	int u,v,
	 	rotate,
	 	collide,		//can stuff collide with this tile?
						// 0 = no 			| 1 = flat ground	| 2 = wall
						// 3 = uneven ground with collision map
		friction;		// friction
						
	}tile;

typedef struct
{
int layerx,				// xoffset for drawing to screen
		layery,				// yoffset for drawing to screen
		r,						// layer normal red
		g,						// layer normal green
		b,						// layer normal blue
		dr,						// layer display red
		dg,						// layer display green
		db						// layer display blue
		;
}drawlayer;

typedef struct
{
	int x, y;
}Vec2i;

typedef struct
{
	GsSPRITE *sprite;		// sprite to use
	int 	x,				// x position	
			y,				// y position
			frame,
			anim;				

}S_entity;

typedef struct
{
	S_entity	entity;
	int 	xvel,				// x vel				
			yvel,				// y vel	
			maxspeed,				
			hillx,
			hilly,
			oldx,
			oldy
			;

}S_object;

typedef struct
{
	S_object object;
	int 	w,				// x position	
			h,				// y position
			health,
		 	jumping,		//players health
			maxjump,
			oldcollision,	//collision with ground stuff
			newcollision;
	Vec2i	lastpos,
			startpos;		//where to start actor at

}S_actor;

typedef struct
{
	S_actor	actor;			//actor for the player
	int 	score,
			discolove,
			showmydiscolove,
		 	records,
			lives;
			
	Vec2i	oldpos[10];
	int		old_at;
			
}S_player;

typedef struct
{
	S_actor	actor;			//actor for the enemy
	int		type,			
			aware,			//is enemy aware of its surroundings 0=no | 1 =turns | 2 = jumps | moves down if poss
	 		aggressive,		//how aggressive is the enemy
	 		provoked,		//has enemy been provoked
 			score 		
			;
}S_enemy;


typedef struct
{
	S_entity	entity;		//entity
	int			type,		//0: vinyl | 1: discoloveflower | 2:moonsuit | 3:firesuit | 4:invincible
							//5: groove trumpet 			| 6: funk accordian		  | 7: help point
				score,
				collected	//1 or 0
				;
}S_collectable;

#endif
